////// VIEW
#define ADC_VREF_TYPE_8 0x20
// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=ADC_VREF_TYPE_8 & 0xff;
ADMUX=adc_input | (ADC_VREF_TYPE_8 & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}



void Charger_Status(){
char title[]="Charger Status";
char st1[] = "Charg Mode    :";
char st2[] = "Charg Voltage :";
char st3[] = "Charg Current :";
char st4[] = "Charg Power   :";
char st5[] = "Current Limit :";

char t1[6];
char t2[6];
char t3[6];
char t4[6];
char t5[6];


if(Shutdown==1)
        sprintf(t1,"OFF");
else
        if(Float==1)
        sprintf(t1,"Float");
        else
        sprintf(t1,"Fast");
sprintf(t3,"%.2f",ISHENT);
sprintf(t2,"%.2f",VVBUT);
sprintf(t4,"%.2f",VVBUT*ISHENT);
if(Limit==1)
        sprintf(t5,"ON");
else
        sprintf(t5,"OFF");
GBcls();
GBFputs(2,2,title);
GBbox(0,0,127,62,black);
GBline(0,10,127,10,black);
GBFputs(4,12+1,st1);
GBFputs(4,20+2,st2);
GBFputs(4,28+3,st3);
GBFputs(4,36+4,st4);
GBFputs(4,44+5,st5);

GBFputs(95,12+1,t1);
GBFputs(95,20+2,t2);
GBFputs(95,28+3,t3);
GBFputs(95,36+4,t4);
GBFputs(95,44+5,t5);
GBupdate();

}


void battry_status(){

char title[]="Battry Status";
char st1[]="Battry Level :";
char st2[]="Battry Volt  :";
float stat;
float volt=VBATTRY;


stat = (VBATTRY-11.9)/0.75*100; 
 if (stat<0) stat=0;
 if(stat>100) stat = 100;


GBcls();
GBFputs(2,2,title);
GBbox(0,0,127,62,black);
GBline(0,10,127,10,black);

GBbox(30,20-5,90,35-5,black);
GBbox(90,20+5-5,96,35-5-5,black);
GBfill_box(32,22-5,32+(56*stat/100),34-5,black);

GBfill_box(2,38,125,61,black);
GBfull_str(10,41,20,st1,1);
sprintf(st1,"%.1f%%",stat);
GBfull_str(93,41,10,st1,1);
GBfull_str(10,51,20,st2,1);
sprintf(st1,"%.2f", volt);
GBfull_str(93,51,10,st1,1);

GBupdate();

}

int _delay;
char ch=0;
char TM_EN=0;
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{


TCCR0=0x00;

}


void Drow_ch(char chanal,unsigned int delay){

char title[];
char st1[20];
char sample[128];
int y;
char i;

_delay=delay;
GBcls(); 
ch=chanal;
sprintf(title,"View CH %i",chanal+1) ;
GBFputs(2,2,title);
GBbox(0,0,127,62,black);
GBline(0,10,127,10,black);
sprintf(st1,"TIME/DIV : %i uS",_delay+30);
GBFputs(2,14,st1);

GBbox(2,23,125,60,black);
//GBfill_box(3,24,124,60,white);
for(i=2;i<126;i++){
 sample[i]= read_adc(ch);  
 y=_delay;
 while(y--!=0)
 delay_us(1);
}
 for(i=3;i<126;i++)
        GBline(i-1,25+(sample[i-1]*(0.125)),i,25+(sample[i]*(0.125)),black);

GBupdate();


}


void MCU_INIT(void){
// USART0 initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART0 Receiver: On
// USART0 Transmitter: On
// USART0 Mode: Asynchronous
// USART0 Baud Rate: 9600
UCSR0A=0x00;
UCSR0B=0x18;
UCSR0C=0x06;
UBRR0H=0x00;
UBRR0L=0x33;

 PORTA=255;
 PORTG=255;
// ADC initialization
// ADC Clock frequency: 1000.000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE_8 & 0xff;
ADCSRA=0x82;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x41;
ETIMSK=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: On
// INT4 Mode: Falling Edge
// INT5: On
// INT5 Mode: Any change
// INT6: Off
// INT7: Off
EICRA=0x00;
EICRB=0x06;
EIMSK=0x30;
EIFR=0x30;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 7.813 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

DDRB=255;
Float=1;
Limit=1;
if(PINE.5==0)
   Shutdown=1;
   
Init();

GBload_font(Defult);  //          
GBSET_RTL(LTR);         // Set RTL Or LTR Direction


#asm("sei")
}