
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

typedef struct struct_GrLcdCtrlrStateType
{
unsigned char xAddr;
unsigned char yAddr;
} GrLcdCtrlrStateType;

typedef struct struct_GrLcdStateType
{
unsigned char lcdXAddr;
unsigned char lcdYAddr;
GrLcdCtrlrStateType ctrlr[((128        +64        -1)/64        )];
} GrLcdStateType;

static GrLcdStateType GrLcdState;

void InitHW(void);
void ControllerSelect(unsigned char controller);
void ControlWrite(unsigned char controller, unsigned char data);
unsigned char  ControlRead(unsigned char controller);
void SetXAddress(unsigned char xAddr);
void SetYAddress(unsigned char yAddr);

void BusyWait(unsigned char controller);
void Reset(unsigned char resetState);
void Write(unsigned char data);

unsigned char  Read(void);

void Init(void);
void ClearScreen(void);
void Home(void);
void SetAddress(unsigned char x, unsigned char yLine);
void StartLine(unsigned char start);

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

void InitHW(void)
{

PORTD &= ~((1<<(0)));
PORTD &= ~((1<<(1)));
PORTD &= ~((1<<(2)));
PORTD &= ~((1<<(3)));
PORTD &= ~((1<<(4)));
PORTD &= ~((1<<(5)));
PORTD &= ~((1<<(6)));
PORTD &= ~((1<<(7)));
DDRD |= ((1<<(0)));
DDRD |= ((1<<(1)));
DDRD |= ((1<<(2)));
DDRD |= ((1<<(3)));
DDRD |= ((1<<(4)));
DDRD |= ((1<<(5)));
DDRD |= ((1<<(6)));
DDRD |= ((1<<(7)));
PORTC = (0x00);
DDRC = (0xFF);

}

void ControllerSelect(unsigned char controller)
{

PORTD &= ~((1<<(3)));
PORTD &= ~((1<<(4)));
PORTD &= ~((1<<(5)));
PORTD &= ~((1<<(6)));

switch(controller)
{
case 0:    PORTD |= ((1<<(3))); break;
case 1:    PORTD |= ((1<<(4))); break;
case 2:	PORTD |= ((1<<(5))); break;
case 3:	PORTD |= ((1<<(6))); break;
default: break;
}

}

void BusyWait(unsigned char controller)
{	
#asm 
	cli 
	#endasm

ControllerSelect(controller);
PORTC = (0xFF);
PORTD &= ~((1<<(0)));
DDRC = (0x00);
PORTD |= ((1<<(1)));
PORTD |= ((1<<(2)));
#asm 
    nop 
    nop
    #endasm
while((PINC) & 0x80    )
{
PORTD &= ~((1<<(2)));
#asm 
        nop 
        nop
        #endasm
PORTD |= ((1<<(2)));
#asm 
        nop 
        nop
        #endasm

}
PORTD &= ~((1<<(2)));
PORTD &= ~((1<<(1)));
DDRC = (0xFF);
#asm 
     sei 
     #endasm
}

void ControlWrite(unsigned char controller, unsigned char data)
{

#asm 
    cli 
    #endasm
BusyWait(controller);
PORTD &= ~((1<<(0)));
PORTD &= ~((1<<(1)));
PORTD |= ((1<<(2)));
DDRC = (0xFF);
PORTC = (data);
PORTD &= ~((1<<(2)));
#asm
    sei
    #endasm
}

unsigned char ControlRead(unsigned char controller)
{
register unsigned char data;

#asm
    cli
    #endasm
BusyWait(controller);
PORTD &= ~((1<<(0)));
DDRC = (0x00);
PORTD |= ((1<<(1)));
PORTD |= ((1<<(2)));
#asm
    nop
    nop
    #endasm
data = (PINC);
PORTD &= ~((1<<(2)));
PORTD &= ~((1<<(1)));
DDRC = (0xFF);
#asm
    sei
    #endasm

return data;
}

void Write(unsigned char data)
{
register unsigned char controller = (GrLcdState.lcdXAddr/64        );

#asm
    cli
    #endasm
BusyWait(controller);
PORTD |= ((1<<(0)));
PORTD &= ~((1<<(1)));
PORTD |= ((1<<(2)));
DDRC = (0xFF);
PORTC = (data);
PORTD &= ~((1<<(2)));
#asm
    sei
    #endasm

GrLcdState.ctrlr[controller].xAddr++;
GrLcdState.lcdXAddr++;
if(GrLcdState.lcdXAddr >= 128        )
{
GrLcdState.lcdYAddr++;
SetYAddress(GrLcdState.lcdYAddr);
SetXAddress(0);
}
}

void SetXAddress(unsigned char xAddr)
{
unsigned char i;

GrLcdState.lcdXAddr = xAddr;

for(i=0; i<((128        +64        -1)/64        ); i++)
{
ControlWrite(i, 0x40     | 0x00);
GrLcdState.ctrlr[i].xAddr = 0;
}

ControlWrite((GrLcdState.lcdXAddr/64        ),
0x40     | (GrLcdState.lcdXAddr & 0x3F));
}

void SetYAddress(unsigned char yAddr)
{
unsigned char i;

GrLcdState.lcdYAddr = yAddr;

for(i=0; i<((128        +64        -1)/64        ); i++)
{
ControlWrite(i, 0xB8     | yAddr);
}
}

unsigned char Read(void)
{
register unsigned char data;
register unsigned char controller = (GrLcdState.lcdXAddr/64        );

#asm
    cli
    #endasm
BusyWait(controller);	
PORTD |= ((1<<(0)));
DDRC = (0x00);
PORTD |= ((1<<(1)));
PORTD |= ((1<<(2)));
data = (PINC);
PORTD &= ~((1<<(2)));
PORTD &= ~((1<<(1)));

BusyWait(controller);		
PORTD |= ((1<<(0)));
DDRC = (0x00);
PORTD |= ((1<<(1)));
PORTD |= ((1<<(2)));
#asm
    nop
    nop
    #endasm

data = (PINC);
PORTD &= ~((1<<(2)));
PORTD &= ~((1<<(1)));
#asm
    sei
    #endasm

GrLcdState.ctrlr[controller].xAddr++;
GrLcdState.lcdXAddr++;
if(GrLcdState.lcdXAddr >= 128        )
{
GrLcdState.lcdYAddr++;
SetYAddress(GrLcdState.lcdYAddr);
SetXAddress(0);
}
return data;
}

void Reset(unsigned char resetState)
{

if(resetState)
PORTD &= ~((1<<(7)));
else
PORTD |= ((1<<(7)));

}

void Init()
{
unsigned char i;

InitHW();

Reset(0);

for(i=0; i<((128        +64        -1)/64        ); i++)
{
ControlWrite(i, 0x3E     | 0x01    );
}

ClearScreen();

Home();
}

void Home(void)
{
unsigned char i;

StartLine(0);
SetAddress(0,0);

for(i=0; i<((128        +64        -1)/64        ); i++)
{
GrLcdState.ctrlr[i].xAddr = 0;
GrLcdState.ctrlr[i].yAddr = 0;
}
}

void ClearScreen(void)
{
unsigned char pageAddr;
unsigned char xAddr;

for(pageAddr=0; pageAddr<(64        >>3); pageAddr++)
{

SetAddress(0, pageAddr);

for(xAddr=0; xAddr<128        ; xAddr++)
{
Write(0x00);
}
}
}

void StartLine(unsigned char start)
{
ControlWrite(0, 0xC0     | start);
ControlWrite(1, 0xC0     | start);
}

void SetAddress(unsigned char x, unsigned char yLine)
{

SetYAddress(yLine);
SetXAddress(x);
}

void Show_Buf(char *Buf){
int i;
SetAddress(0,0);
for(i=0;i<1024;i++)
Write(*Buf++);
}

char gbuf[128*64/8];
void Init(void);
void GBSET_RTL(char Posion);        
char GBRead(char x, char y);
void GBWrite(char x, char y, char data);
void GBGWrite(char x, char y,char _bit ,char data);
void GBcls(void);
void GBupdate(void);
void GBpset(char x,char y);
void GBReset(char x,char y);
void GBline(int startx,int starty,int endx,int endy,char color);
void GBCircle(unsigned char xcenter,unsigned char ycenter,unsigned char radius);
void GBload_font(flash char *font);
unsigned char GBget_font(unsigned int adr);
void GBputchar(unsigned char x, unsigned char y, char ch);
void GBPputchar(char x,char y,char c);
void GBPputs(char x,char y,char *c);
void GBputs(unsigned char x, unsigned char y, char *st);
void GBFputs(unsigned char x, unsigned char y,char *st);
void GBputsf (unsigned char x, unsigned char y,unsigned int len ,char *st);
void GBbox(int startx,int starty,int endx,int endy,char color);
void GBfill_box(int startx,int starty,int endx,int endy,char color);
void GBfull_str(int x,int y,int len,char *st,char inv);    

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

flash unsigned char map[121][6] = {{243,248,247,246,1,1},{130,0,0,0,0,0},{131,0,0,0,0,0},{132,0,0,0,0,0},{133,0,0,0,0,0},{134,0,0,0,0,0},{135,0,0,0,0,0},{136,0,0,0,0,0},{137,0,0,0,0,0},{138,0,0,0,0,0},{139,0,0,0,0,0},{140,0,0,0,0,0},{7,8,7,8,1,1},{1,1,2,2,1,0},{143,0,0,0,0,0},{3,4,5,6,1,1},{145,0,0,0,0,0},{146,0,0,0,0,0},{147,0,0,0,0,0},{148,0,0,0,0,0},{149,0,0,0,0,0},{150,0,0,0,0,0},{151,0,0,0,0,0},{223,172,174,173,1,1},{153,0,0,0,0,0},{154,0,0,0,0,0},{155,0,0,0,0,0},{156,0,0,0,0,0},{157,0,0,0,0,0},{158,0,0,0,0,0},{159,0,0,0,0,0},{160,0,0,0,0,0},{161,0,0,0,0,0},{162,0,0,0,0,0},{163,0,0,0,0,0},{164,0,0,0,0,0},{165,0,0,0,0,0},{166,0,0,0,0,0},{167,0,0,0,0,0},{168,0,0,0,0,0},{169,0,0,0,0,0},{170,0,0,0,0,0},{171,0,0,0,0,0},{172,0,0,0,0,0},{173,0,0,0,0,0},{174,0,0,0,0,0},{175,0,0,0,0,0},{176,0,0,0,0,0},{177,0,0,0,0,0},{178,0,0,0,0,0},{179,0,0,0,0,0},{180,0,0,0,0,0},{181,0,0,0,0,0},{182,0,0,0,0,0},{183,0,0,0,0,0},{184,0,0,0,0,0},{185,0,0,0,0,0},{186,0,0,0,0,0},{187,0,0,0,0,0},{188,0,0,0,0,0},{189,0,0,0,0,0},{190,0,0,0,0,0},{191,0,0,0,0,0},{192,0,0,0,0,0},{193,193,193,193,0,0},{194,194,254,254,1,0},{195,195,129,129,1,0},{196,196,252,252,1,0},{197,197,197,197,1,1},{198,189,191,190,1,1},{199,199,192,192,1,0},{200,130,132,131,1,1},{201,201,253,253,1,0},{202,133,135,134,1,1},{203,136,138,137,1,1},{204,139,204,139,1,1},{205,140,205,140,1,1},{206,141,206,141,1,1},{207,207,142,142,1,0},{208,208,143,143,1,0},{209,209,144,144,1,0},{210,210,145,145,1,0},{211,146,148,147,1,1},{212,149,151,150,1,1},{213,152,154,153,1,1},{214,155,157,156,1,1},{215,215,215,215,0,0},{216,216,158,158,1,1},{217,217,159,159,1,1},{218,160,162,161,1,1},{219,163,165,164,1,1},{220,220,220,220,0,0},{221,166,168,167,1,1},{222,169,171,170,1,1},{223,172,174,173,1,1},{224,224,224,224,0,0},{225,175,177,176,1,1},{226,226,266,226,0,0},{227,178,180,179,1,1},{228,181,183,182,1,1},{229,184,186,185,1,1},{230,230,188,188,1,0},{231,231,231,231,0,0},{232,232,232,232,0,0},{233,233,233,233,0,0},{234,234,234,234,0,0},{235,235,235,235,0,0},{236,189,191,190,1,1},{237,189,191,190,1,1},{238,238,238,238,0,0},{239,239,239,239,0,0},{240,240,240,240,0,0},{241,241,241,241,0,0},{242,242,242,242,0,0},{243,243,243,243,0,0},{245,245,245,245,0,0},{246,246,246,246,0,0},{247,247,247,247,0,0},{248,248,248,248,0,0},{251,249,251,250,1,1},{187,187,244,244,1,0}};typedef struct _FontDescriptor{unsigned char SIZE_X;unsigned char SIZE_Y;unsigned char Start_ch;unsigned char End_ch;flash char *adr;}FontDescriptor;static int prevLet = 193;static char stat = 0;static char prevX = 0;static char prevY = 0;FontDescriptor GBFont;flash char GBGAND[]={1,2,4,8,16,32,64,128};char _RTL = 0x1C;void GBSET_RTL(char Posion){if(Posion==0x1C)_RTL=0x1C;  else  _RTL=~0x1C;}void GBload_font(flash char *font){GBFont.SIZE_X =font[1];GBFont.SIZE_Y =font[2];GBFont.Start_ch=font[3];GBFont.End_ch=font[4];GBFont.adr =font;}unsigned char GBget_font(unsigned int adr){return GBFont.adr[5+adr];}char GBRead(char x, char y){x=(_RTL==0x1C) ? x:128-x;return gbuf[x+y*128];}void GBWrite(char x, char y, char data){ x=(_RTL==0x1C) ? x:128-x;gbuf[x+y*128]=data;}void GBGWrite(char x, char y,char _bit ,char data){char j;for(j=0;j<_bit;j++){if((data&GBGAND[j]) != 0) GBpset(x,y+j);  else  GBReset(x,y+j);}}void GBcls(void){int i;for(i=0; i<128*64/8 ; i++)gbuf[i]=0;}void GBupdate(void){Show_Buf(gbuf);}void GBpset(char x,char y){int temp;x=(_RTL==0x1C) ? x:128-x;temp = x+(y/8)*128;gbuf[temp]=gbuf[temp] | (GBGAND[(y % 8)]);}void GBReset(char x,char y){int temp;x=(_RTL==0x1C) ? x:128-x;temp = x+(y/8)*128;gbuf[temp]=gbuf[temp] & ~(GBGAND[(y % 8)]);}void GBline(int startx,int starty,int endx,int endy,char color){register int t,distance;int xerr=0,yerr=0,deltax,deltay;int incx,incy;deltax=endx-startx;deltay=endy-starty;if (deltax>0)incx=1; else  if(deltax==0)incx=0; else incx=-1;if (deltay>0)incy=1; else  if(deltay==0)incy=0; else incy=-1;deltax=abs(deltax);deltay=abs(deltay);if (deltax>deltay)distance=deltax; else distance=deltay;for (t=0;t<distance+1;t++){if(color==0) GBReset(startx,starty); else GBpset(startx,starty);xerr +=deltax;yerr +=deltay;if(xerr>distance){xerr -=distance;startx +=incx;}if(yerr>distance){yerr -=distance;starty +=incy;}}}void GBCircle(unsigned char xcenter,unsigned char ycenter,unsigned char radius){int tswitch, y, x = 0;unsigned char d;d = ycenter - xcenter;y = radius;tswitch = 3 - 2 * radius;while (x <= y) {GBpset(xcenter + x, ycenter + y);     GBpset(xcenter + x, ycenter - y);GBpset(xcenter - x, ycenter + y);     GBpset(xcenter - x, ycenter - y);GBpset(ycenter + y - d, ycenter + x); GBpset(ycenter + y - d, ycenter - x);GBpset(ycenter - y - d, ycenter + x); GBpset(ycenter - y - d, ycenter - x);if (tswitch < 0) tswitch += (4 * x + 6); else  {tswitch += (4 * (x - y) + 10);y--;}x++;}}void GBputchar(unsigned char x, unsigned char y, char ch){unsigned char temp;unsigned char i;for(i=0;i<GBFont.SIZE_X;i++){temp=GBget_font(i+((ch-GBFont.Start_ch)*GBFont.SIZE_X));GBGWrite(x+i,y,GBFont.SIZE_Y,temp);}}void GBPputchar(char x,char y,char c){if((map[prevLet-129][5]) && (map[c-129][4]) && (c >= 129) && (prevLet >= 129)){GBputchar(prevX,prevY,map[prevLet-129][stat+1]);stat = 2;} else  stat = 0;if(c >= 129) GBputchar(x,y,map[c-129][stat]); else  GBputchar(x,y,c);prevLet = c;prevX = x;prevY = y;}void GBputs(unsigned char x, unsigned char y, char *st){char *temp,i=0;temp=st;while(*temp!=0){GBputchar(x+i,y,*temp);i+=GBFont.SIZE_X+1;temp++;}}void GBPputs(char x,char y,char *c){ char i = 0;char special = 0;x= 128 - 8 - x;while(i<strlen(c)){if((*(c+i) == 225) && (*(c+i+1) == 199))special = 249; else  if((*(c+i) == 225) && (*(c+i+1) == 195))special = 231; else  if((*(c+i) == 225) && (*(c+i+1) == 194))special = 232; else  if((*(c+i) == 225) && (*(c+i+1) == 197))special = 233;if(special){GBPputchar(x,y,special);i+=2;x -= 8;special = 0;continue;}GBPputchar(x,y,*(c+i));x -= 8;if(x < 0){x=120;y++;}i++;}prevLet = 193;}void GBputsf (unsigned char x, unsigned char y,unsigned int len ,char *st){char *temp,i=0;temp=st;while(*temp!=0 && len--!=0){GBputchar(x+i,y,*temp);i+=GBFont.SIZE_X+1;temp++;}}void GBFputs(unsigned char x, unsigned char y,char *st){char a=*st;if(a>=129)GBPputs(x,y,st); else GBputs(x,y,st);}void GBbox(int startx,int starty,int endx,int endy,char color){GBline(startx,starty,startx,endy+1,color);GBline(startx,starty,endx,starty,color);GBline(startx,endy+1,endx+1,endy+1,color);GBline(endx,starty,endx,endy+1,color);}void GBfill_box(int startx,int starty,int endx,int endy,char color){int i=0,j=0;if(starty>endy){i=endy;endy=starty;starty=i;}if(startx>endx){i=endx;endx=startx;startx=i;}for(i=startx;i<=endx;i++){for(j=starty;j<=endy;j++){if(color==0) GBReset(i,j); else  GBpset(i,j);}}}void GBfull_str(int x,int y,int len,char *st,char inv){unsigned char temp;char *stt;int u=0;unsigned char i,j,ch;stt=st;    while(*stt!=0 && len--!=0){   ch=*stt++;     for(i=0;i<GBFont.SIZE_X;i++){temp=GBget_font(i+((ch-GBFont.Start_ch)*GBFont.SIZE_X));if(inv!=0)temp=~temp;for(j=0;j<GBFont.SIZE_Y;j++)if((temp)&(1<<j))   GBpset(x+i+u,y+j); else GBReset(x+i+u,y+j);}for(j=0;j<GBFont.SIZE_Y;j++)if(inv!=0)GBpset(x+GBFont.SIZE_X+u,y+j); else GBReset(x+GBFont.SIZE_X+u,y+j);u+=GBFont.SIZE_X+1;}}

flash char  Defult[] = {96,5,7,0x20,0x7e,
0x00,0x00,0x00,0x00,0x00,	
0x00,0x00,0x5f,0x00,0x00,	
0x00,0x07,0x00,0x07,0x00,	
0x14,0x7f,0x14,0x7f,0x14,	
0x24,0x2a,0x7f,0x2a,0x12,	
0x23,0x13,0x08,0x64,0x62,	
0x36,0x49,0x55,0x22,0x50,	
0x00,0x05,0x03,0x00,0x00,	
0x00,0x1c,0x22,0x41,0x00,	
0x00,0x41,0x22,0x1c,0x00,	
0x14,0x08,0x3e,0x08,0x14,	
0x08,0x08,0x3e,0x08,0x08,	
0x00,0x50,0x30,0x00,0x00,	
0x08,0x08,0x08,0x08,0x08,	
0x00,0x60,0x60,0x00,0x00,	
0x20,0x10,0x08,0x04,0x02,	
0x3e,0x51,0x49,0x45,0x3e,	
0x00,0x42,0x7f,0x40,0x00,	
0x42,0x61,0x51,0x49,0x46,	
0x21,0x41,0x45,0x4b,0x31,	
0x18,0x14,0x12,0x7f,0x10,	
0x27,0x45,0x45,0x45,0x39,	
0x3c,0x4a,0x49,0x49,0x30,	
0x01,0x71,0x09,0x05,0x03,	
0x36,0x49,0x49,0x49,0x36,	
0x06,0x49,0x49,0x29,0x1e,	
0x00,0x36,0x36,0x00,0x00,	
0x00,0x56,0x36,0x00,0x00,	
0x08,0x14,0x22,0x41,0x00,	
0x14,0x14,0x14,0x14,0x14,	
0x00,0x41,0x22,0x14,0x08,	
0x02,0x01,0x51,0x09,0x06,	
0x32,0x49,0x79,0x41,0x3e,	
0x7e,0x11,0x11,0x11,0x7e,	
0x7f,0x49,0x49,0x49,0x36,	
0x3e,0x41,0x41,0x41,0x22,	
0x7f,0x41,0x41,0x22,0x1c,	
0x7f,0x49,0x49,0x49,0x41,	
0x7f,0x09,0x09,0x09,0x01,	
0x3e,0x41,0x49,0x49,0x7a,	
0x7f,0x08,0x08,0x08,0x7f,	
0x00,0x41,0x7f,0x41,0x00,	
0x20,0x40,0x41,0x3f,0x01,	
0x7f,0x08,0x14,0x22,0x41,	
0x7f,0x40,0x40,0x40,0x40,	
0x7f,0x02,0x0c,0x02,0x7f,	
0x7f,0x04,0x08,0x10,0x7f,	
0x3e,0x41,0x41,0x41,0x3e,	
0x7f,0x09,0x09,0x09,0x06,	
0x3e,0x41,0x51,0x21,0x5e,	
0x7f,0x09,0x19,0x29,0x46,	
0x46,0x49,0x49,0x49,0x31,	
0x01,0x01,0x7f,0x01,0x01,	
0x3f,0x40,0x40,0x40,0x3f,	
0x1f,0x20,0x40,0x20,0x1f,	
0x3f,0x40,0x38,0x40,0x3f,	
0x63,0x14,0x08,0x14,0x63,	
0x07,0x08,0x70,0x08,0x07,	
0x61,0x51,0x49,0x45,0x43,	
0x00,0x7f,0x41,0x41,0x00,	
0x02,0x04,0x08,0x10,0x20,	
0x00,0x41,0x41,0x7f,0x00,	
0x04,0x02,0x01,0x02,0x04,	
0x40,0x40,0x40,0x40,0x40,	
0x00,0x01,0x02,0x04,0x00,	
0x20,0x54,0x54,0x54,0x78,	
0x7f,0x48,0x44,0x44,0x38,	
0x38,0x44,0x44,0x44,0x20,	
0x38,0x44,0x44,0x48,0x7f,	
0x38,0x54,0x54,0x54,0x18,	
0x08,0x7e,0x09,0x01,0x02,	
0x0c,0x52,0x52,0x52,0x3e,	
0x7f,0x08,0x04,0x04,0x78,	
0x00,0x44,0x7d,0x40,0x00,	
0x20,0x40,0x44,0x3d,0x00,	
0x7f,0x10,0x28,0x44,0x00,	
0x00,0x41,0x7f,0x40,0x00,	
0x7c,0x04,0x18,0x04,0x78,	
0x7c,0x08,0x04,0x04,0x78,	
0x38,0x44,0x44,0x44,0x38,	
0x7c,0x14,0x14,0x14,0x08,	
0x08,0x14,0x14,0x18,0x7c,	
0x7c,0x08,0x04,0x04,0x08,	
0x48,0x54,0x54,0x54,0x20,	
0x04,0x3f,0x44,0x40,0x20,	
0x3c,0x40,0x40,0x20,0x7c,	
0x1c,0x20,0x40,0x20,0x1c,	
0x3c,0x40,0x30,0x40,0x3c,	
0x44,0x28,0x10,0x28,0x44,	
0x0c,0x50,0x50,0x50,0x3c,	
0x44,0x64,0x54,0x4c,0x44,	
0x00,0x08,0x36,0x41,0x00,	
0x00,0x00,0x7f,0x00,0x00,	
0x00,0x41,0x36,0x08,0x00,	
0x10,0x08,0x08,0x10,0x08,	
0x78,0x46,0x41,0x46,0x78};

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned int read_adc10bit(unsigned char adc_input)
{
ADMUX=0x00 & 0xff; 
ADMUX=adc_input | (0x00 & 0xff);

delay_us(10);

ADCSRA|=0x40;

while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

float VBATTRY;
float get_status(void){

float stat;

PORTB.2=1;
VBATTRY=(read_adc10bit(6)-read_adc10bit(7))*0.024414;
stat = (VBATTRY-11.9)/0.75*100; 
if (stat<0) stat=10;
if(PINE.5==1)
PORTB.2=0;
return stat;
}

void set_charge_type(){
float s;

s=get_status();
if(PINE.5==0)
return;
if(s>=95){
if(PORTB.0!=1)
PORTB.0=1;PORTB.1=0;
}else{
if(PORTB.1!=1)
PORTB.1=1;PORTB.0=0;
} 
} 

char tukometr=0;

interrupt [11] void timer2_ovf_isr(void)
{
if(tukometr++>=1){
tukometr=0;
set_charge_type();
}
}

unsigned char read_adc(unsigned char adc_input)
{
ADMUX=0x20 & 0xff;
ADMUX=adc_input | (0x20 & 0xff);

delay_us(10);

ADCSRA|=0x40;

while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}

void Charger_Status(){
char title[]="Charger Status";
char st1[] = "Charg Mode    :";
char st2[] = "Charg Voltage :";
char st3[] = "Charg Current :";
char st4[] = "Charg Power   :";
char st5[] = "Current Limit :";

char t1[6];
char t2[6];
char t3[6];
char t4[6];
char t5[6];

if(PORTB.2==1)
sprintf(t1,"OFF");
else
if(PORTB.0==1)
sprintf(t1,"Float");
else
sprintf(t1,"Fast");
sprintf(t3,"%.2f",read_adc10bit(7)*0.028722);
sprintf(t2,"%.2f",(read_adc10bit(6)-read_adc10bit(7))*0.024414);
sprintf(t4,"%.2f",(read_adc10bit(6)-read_adc10bit(7))*0.024414*read_adc10bit(7)*0.028722);
if(PORTB.3==1)
sprintf(t5,"ON");
else
sprintf(t5,"OFF");
GBcls();
GBFputs(2,2,title);
GBbox(0,0,127,62,1);
GBline(0,10,127,10,1);
GBFputs(4,12+1,st1);
GBFputs(4,20+2,st2);
GBFputs(4,28+3,st3);
GBFputs(4,36+4,st4);
GBFputs(4,44+5,st5);

GBFputs(95,12+1,t1);
GBFputs(95,20+2,t2);
GBFputs(95,28+3,t3);
GBFputs(95,36+4,t4);
GBFputs(95,44+5,t5);
GBupdate();

}

void battry_status(){

char title[]="Battry Status";
char st1[]="Battry Level :";
char st2[]="Battry Volt  :";
float stat;
float volt=VBATTRY;

stat = (VBATTRY-11.9)/0.75*100; 
if (stat<0) stat=0;
if(stat>100) stat = 100;

GBcls();
GBFputs(2,2,title);
GBbox(0,0,127,62,1);
GBline(0,10,127,10,1);

GBbox(30,20-5,90,35-5,1);
GBbox(90,20+5-5,96,35-5-5,1);
GBfill_box(32,22-5,32+(56*stat/100),34-5,1);

GBfill_box(2,38,125,61,1);
GBfull_str(10,41,20,st1,1);
sprintf(st1,"%.1f%%",stat);
GBfull_str(93,41,10,st1,1);
GBfull_str(10,51,20,st2,1);
sprintf(st1,"%.2f", volt);
GBfull_str(93,51,10,st1,1);

GBupdate();

}

int _delay;
char ch=0;
char TM_EN=0;

interrupt [17] void timer0_ovf_isr(void)
{

TCCR0=0x00;

}

void Drow_ch(char chanal,unsigned int delay){

char title[];
char st1[20];
char sample[128];
int y;
char i;

_delay=delay;
GBcls(); 
ch=chanal;
sprintf(title,"View CH %i",chanal+1) ;
GBFputs(2,2,title);
GBbox(0,0,127,62,1);
GBline(0,10,127,10,1);
sprintf(st1,"TIME/DIV : %i uS",_delay+30);
GBFputs(2,14,st1);

GBbox(2,23,125,60,1);

for(i=2;i<126;i++){
sample[i]= read_adc(ch);  
y=_delay;
while(y--!=0)
delay_us(1);
}
for(i=3;i<126;i++)
GBline(i-1,25+(sample[i-1]*(0.125)),i,25+(sample[i]*(0.125)),1);

GBupdate();

}

void MCU_INIT(void){

UCSR0A=0x00;
UCSR0B=0x18;
(*(unsigned char *) 0x95)=0x06;
(*(unsigned char *) 0x90)=0x00;
UBRR0L=0x33;

PORTA=255;
(*(unsigned char *) 0x65)=255;

ADMUX=0x20 & 0xff;
ADCSRA=0x82;

TIMSK=0x41;
(*(unsigned char *) 0x7d)=0x00;

(*(unsigned char *) 0x6a)=0x00;
EICRB=0x06;
EIMSK=0x30;
EIFR=0x30;

TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

DDRB=255;
PORTB.0=1;
PORTB.3=1;
if(PINE.5==0)
PORTB.2=1;

Init();

GBload_font(Defult);  
GBSET_RTL(0x1C);         

#asm("sei")
}

char job=1;
char rate=10;

interrupt [6] void ext_int4_isr(void)
{

job=~PINA;
rate=(~(*(unsigned char *) 0x63))&0b00011111;
}

interrupt [7] void ext_int5_isr(void)
{
if(PINE.5==1)
PORTB.2=0;
else
PORTB.2=1;
}

void main(void)
{

MCU_INIT();

while (1)
{
switch(job){ 
case 1:

Charger_Status();
break;
case 2:
Drow_ch(0,rate*10);
break;
case 4:
Drow_ch(1,rate*10);
break; 
case 8:
battry_status();
break;
case 16:
PORTB.3=~PORTB.3;
if(PORTB.3==1)
printf("Current limiter Enable%c",13);
else
printf("Current limiter Desable%c",13);
job=1;
break;
}

};
}
