/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://electroprojects.ir

Project : 
Version : 
Date    : 2010/06/28
Author  : 
Company : 
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4.000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>

// Standard Input/Output functions
#include <stdio.h>

#include <delay.h>

#define ADC_VREF_TYPE 0x00

#define Battry_CELL 6   //12V

#define NSHENT  read_adc(1)
#define VSHENT  NSHENT*0.004883
#define ISHENT  NSHENT*0.028722

#define NBUT    read_adc(0)
#define VBUT    NBUT*0.004883

#define NNBUT   (NBUT-NSHENT)
#define VVBUT   NNBUT*0.024414


#define Float   PORTB.0
#define Fast    PORTB.1
#define Shutdown    PORTB.2
#define Limit   PORTB.3
// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

// Declare your global variables here
float get_status(void){

 float stat;
 
 Shutdown=1;
 stat = (VVBUT-11.9)/0.75*100; 
 if (stat<0) stat=10;
 if(PIND.3==1)
    Shutdown=0;
 return stat;
}


void set_charge_type(){
float s;
if(PIND.3==0)
    return;
    s=get_status();
if(s>=95){
    if(Float!=1)
    Float=1;Fast=0;
 }else{
    if(Fast!=1)
   Fast=1;Float=0;
 }
 
} 

char resh=0;
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
if(resh++>=15){
set_charge_type();
 resh=0;
}
}

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
// Place your code here
    if(PIND.3==1)
        Shutdown=0;
    else
        Shutdown=1;
}


void main(void)
{
// Declare your local variables here
char ch;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 3.906 kHz
TCCR0=0x05;
TCNT0=0x00;


// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

DDRB=255;
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Any change
GICR|=0x80;
MCUCR=0x04;
GIFR=0x80;

// ADC initialization
// ADC Clock frequency: 1000.000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x82;

Float=1;
Limit=1;
if(PIND.3==0)
   Shutdown=1;
    
delay_ms(1);
// Global enable interrupts
#asm("sei")


while (1)
      {
      // Place your code here
       ch=getchar();
       switch(ch){
        case 'p':
         printf("PARAMT...%c",13);
         printf("VSH=%.2f%c",VSHENT,13);
         printf("ISH=%.2f%c",ISHENT,13);
         printf("BUTTRY=%.2f%c",VVBUT,13);
         printf("Power =%.3f W%c",VVBUT*ISHENT,13);
         break;  
        case 'v':
            Shutdown=1;
            printf("Get V Battry...%cBATTRY=%.2f%c",13,VVBUT,13);
            if(PIND.3==1)
            Shutdown=0;
        break;
        case 's':
            printf("State of Charge in %%%cCharge=%.1f%%%c",13,get_status(),13);
        break;    
        case 'c':
            set_charge_type();
            if(Shutdown==1)
                printf("Charge in Shutdown mode.%c",13);
            else
             if(Float==1)
                printf("Charge in Float mode.%c",13);
            else
                printf("Charge in Fast mode.%c",13);
        break;
        case 'l':
           Limit=~Limit;
           if(Limit==1)
                printf("Current limiter Enable%c",13);
            else
                printf("Current limiter Desable%c",13);
        break;
       }
      };
}
