
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (0x00 & 0xff);

delay_us(10);

ADCSRA|=0x40;

while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

float get_status(void){

float stat;

PORTB.2=1;
stat = ((read_adc(0)-read_adc(1))*0.024414-11.9)/0.75*100; 
if (stat<0) stat=10;
if(PIND.3==1)
PORTB.2=0;
return stat;
}

void set_charge_type(){
float s;
if(PIND.3==0)
return;
s=get_status();
if(s>=95){
if(PORTB.0!=1)
PORTB.0=1;PORTB.1=0;
}else{
if(PORTB.1!=1)
PORTB.1=1;PORTB.0=0;
}

} 

char resh=0;

interrupt [10] void timer0_ovf_isr(void)
{

if(resh++>=15){
set_charge_type();
resh=0;
}
}

interrupt [3] void ext_int1_isr(void)
{

if(PIND.3==1)
PORTB.2=0;
else
PORTB.2=1;
}

void main(void)
{

char ch;

TCCR0=0x05;
TCNT0=0x00;

TIMSK=0x01;

DDRB=255;

UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

ACSR=0x80;
SFIOR=0x00;

GICR|=0x80;
MCUCR=0x04;
GIFR=0x80;

ADMUX=0x00 & 0xff;
ADCSRA=0x82;

PORTB.0=1;
PORTB.3=1;
if(PIND.3==0)
PORTB.2=1;

delay_ms(1);

#asm("sei")

while (1)
{

ch=getchar();
switch(ch){
case 'p':
printf("PARAMT...%c",13);
printf("VSH=%.2f%c",read_adc(1)*0.004883,13);
printf("ISH=%.2f%c",read_adc(1)*0.028722,13);
printf("BUTTRY=%.2f%c",(read_adc(0)-read_adc(1))*0.024414,13);
printf("Power =%.3f W%c",(read_adc(0)-read_adc(1))*0.024414*read_adc(1)*0.028722,13);
break;  
case 'v':
PORTB.2=1;
printf("Get V Battry...%cBATTRY=%.2f%c",13,(read_adc(0)-read_adc(1))*0.024414,13);
if(PIND.3==1)
PORTB.2=0;
break;
case 's':
printf("State of Charge in %%%cCharge=%.1f%%%c",13,get_status(),13);
break;    
case 'c':
set_charge_type();
if(PORTB.2==1)
printf("Charge in Shutdown mode.%c",13);
else
if(PORTB.0==1)
printf("Charge in Float mode.%c",13);
else
printf("Charge in Fast mode.%c",13);
break;
case 'l':
PORTB.3=~PORTB.3;
if(PORTB.3==1)
printf("Current limiter Enable%c",13);
else
printf("Current limiter Desable%c",13);
break;
}
};
}
