
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega64
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : float, width, precision
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega64
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF __RTL=R5
	.DEF _tukometr=R4
	.DEF __delay=R6
	.DEF _ch=R9
	.DEF _TM_EN=R8
	.DEF _job=R11
	.DEF _rate=R10

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _ext_int4_isr
	JMP  _ext_int5_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_map:
	.DB  0xF3,0xF8,0xF7,0xF6,0x1,0x1,0x82,0x0
	.DB  0x0,0x0,0x0,0x0,0x83,0x0,0x0,0x0
	.DB  0x0,0x0,0x84,0x0,0x0,0x0,0x0,0x0
	.DB  0x85,0x0,0x0,0x0,0x0,0x0,0x86,0x0
	.DB  0x0,0x0,0x0,0x0,0x87,0x0,0x0,0x0
	.DB  0x0,0x0,0x88,0x0,0x0,0x0,0x0,0x0
	.DB  0x89,0x0,0x0,0x0,0x0,0x0,0x8A,0x0
	.DB  0x0,0x0,0x0,0x0,0x8B,0x0,0x0,0x0
	.DB  0x0,0x0,0x8C,0x0,0x0,0x0,0x0,0x0
	.DB  0x7,0x8,0x7,0x8,0x1,0x1,0x1,0x1
	.DB  0x2,0x2,0x1,0x0,0x8F,0x0,0x0,0x0
	.DB  0x0,0x0,0x3,0x4,0x5,0x6,0x1,0x1
	.DB  0x91,0x0,0x0,0x0,0x0,0x0,0x92,0x0
	.DB  0x0,0x0,0x0,0x0,0x93,0x0,0x0,0x0
	.DB  0x0,0x0,0x94,0x0,0x0,0x0,0x0,0x0
	.DB  0x95,0x0,0x0,0x0,0x0,0x0,0x96,0x0
	.DB  0x0,0x0,0x0,0x0,0x97,0x0,0x0,0x0
	.DB  0x0,0x0,0xDF,0xAC,0xAE,0xAD,0x1,0x1
	.DB  0x99,0x0,0x0,0x0,0x0,0x0,0x9A,0x0
	.DB  0x0,0x0,0x0,0x0,0x9B,0x0,0x0,0x0
	.DB  0x0,0x0,0x9C,0x0,0x0,0x0,0x0,0x0
	.DB  0x9D,0x0,0x0,0x0,0x0,0x0,0x9E,0x0
	.DB  0x0,0x0,0x0,0x0,0x9F,0x0,0x0,0x0
	.DB  0x0,0x0,0xA0,0x0,0x0,0x0,0x0,0x0
	.DB  0xA1,0x0,0x0,0x0,0x0,0x0,0xA2,0x0
	.DB  0x0,0x0,0x0,0x0,0xA3,0x0,0x0,0x0
	.DB  0x0,0x0,0xA4,0x0,0x0,0x0,0x0,0x0
	.DB  0xA5,0x0,0x0,0x0,0x0,0x0,0xA6,0x0
	.DB  0x0,0x0,0x0,0x0,0xA7,0x0,0x0,0x0
	.DB  0x0,0x0,0xA8,0x0,0x0,0x0,0x0,0x0
	.DB  0xA9,0x0,0x0,0x0,0x0,0x0,0xAA,0x0
	.DB  0x0,0x0,0x0,0x0,0xAB,0x0,0x0,0x0
	.DB  0x0,0x0,0xAC,0x0,0x0,0x0,0x0,0x0
	.DB  0xAD,0x0,0x0,0x0,0x0,0x0,0xAE,0x0
	.DB  0x0,0x0,0x0,0x0,0xAF,0x0,0x0,0x0
	.DB  0x0,0x0,0xB0,0x0,0x0,0x0,0x0,0x0
	.DB  0xB1,0x0,0x0,0x0,0x0,0x0,0xB2,0x0
	.DB  0x0,0x0,0x0,0x0,0xB3,0x0,0x0,0x0
	.DB  0x0,0x0,0xB4,0x0,0x0,0x0,0x0,0x0
	.DB  0xB5,0x0,0x0,0x0,0x0,0x0,0xB6,0x0
	.DB  0x0,0x0,0x0,0x0,0xB7,0x0,0x0,0x0
	.DB  0x0,0x0,0xB8,0x0,0x0,0x0,0x0,0x0
	.DB  0xB9,0x0,0x0,0x0,0x0,0x0,0xBA,0x0
	.DB  0x0,0x0,0x0,0x0,0xBB,0x0,0x0,0x0
	.DB  0x0,0x0,0xBC,0x0,0x0,0x0,0x0,0x0
	.DB  0xBD,0x0,0x0,0x0,0x0,0x0,0xBE,0x0
	.DB  0x0,0x0,0x0,0x0,0xBF,0x0,0x0,0x0
	.DB  0x0,0x0,0xC0,0x0,0x0,0x0,0x0,0x0
	.DB  0xC1,0xC1,0xC1,0xC1,0x0,0x0,0xC2,0xC2
	.DB  0xFE,0xFE,0x1,0x0,0xC3,0xC3,0x81,0x81
	.DB  0x1,0x0,0xC4,0xC4,0xFC,0xFC,0x1,0x0
	.DB  0xC5,0xC5,0xC5,0xC5,0x1,0x1,0xC6,0xBD
	.DB  0xBF,0xBE,0x1,0x1,0xC7,0xC7,0xC0,0xC0
	.DB  0x1,0x0,0xC8,0x82,0x84,0x83,0x1,0x1
	.DB  0xC9,0xC9,0xFD,0xFD,0x1,0x0,0xCA,0x85
	.DB  0x87,0x86,0x1,0x1,0xCB,0x88,0x8A,0x89
	.DB  0x1,0x1,0xCC,0x8B,0xCC,0x8B,0x1,0x1
	.DB  0xCD,0x8C,0xCD,0x8C,0x1,0x1,0xCE,0x8D
	.DB  0xCE,0x8D,0x1,0x1,0xCF,0xCF,0x8E,0x8E
	.DB  0x1,0x0,0xD0,0xD0,0x8F,0x8F,0x1,0x0
	.DB  0xD1,0xD1,0x90,0x90,0x1,0x0,0xD2,0xD2
	.DB  0x91,0x91,0x1,0x0,0xD3,0x92,0x94,0x93
	.DB  0x1,0x1,0xD4,0x95,0x97,0x96,0x1,0x1
	.DB  0xD5,0x98,0x9A,0x99,0x1,0x1,0xD6,0x9B
	.DB  0x9D,0x9C,0x1,0x1,0xD7,0xD7,0xD7,0xD7
	.DB  0x0,0x0,0xD8,0xD8,0x9E,0x9E,0x1,0x1
	.DB  0xD9,0xD9,0x9F,0x9F,0x1,0x1,0xDA,0xA0
	.DB  0xA2,0xA1,0x1,0x1,0xDB,0xA3,0xA5,0xA4
	.DB  0x1,0x1,0xDC,0xDC,0xDC,0xDC,0x0,0x0
	.DB  0xDD,0xA6,0xA8,0xA7,0x1,0x1,0xDE,0xA9
	.DB  0xAB,0xAA,0x1,0x1,0xDF,0xAC,0xAE,0xAD
	.DB  0x1,0x1,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xE1,0xAF,0xB1,0xB0,0x1,0x1,0xE2,0xE2
	.DB  0xA,0xE2,0x0,0x0,0xE3,0xB2,0xB4,0xB3
	.DB  0x1,0x1,0xE4,0xB5,0xB7,0xB6,0x1,0x1
	.DB  0xE5,0xB8,0xBA,0xB9,0x1,0x1,0xE6,0xE6
	.DB  0xBC,0xBC,0x1,0x0,0xE7,0xE7,0xE7,0xE7
	.DB  0x0,0x0,0xE8,0xE8,0xE8,0xE8,0x0,0x0
	.DB  0xE9,0xE9,0xE9,0xE9,0x0,0x0,0xEA,0xEA
	.DB  0xEA,0xEA,0x0,0x0,0xEB,0xEB,0xEB,0xEB
	.DB  0x0,0x0,0xEC,0xBD,0xBF,0xBE,0x1,0x1
	.DB  0xED,0xBD,0xBF,0xBE,0x1,0x1,0xEE,0xEE
	.DB  0xEE,0xEE,0x0,0x0,0xEF,0xEF,0xEF,0xEF
	.DB  0x0,0x0,0xF0,0xF0,0xF0,0xF0,0x0,0x0
	.DB  0xF1,0xF1,0xF1,0xF1,0x0,0x0,0xF2,0xF2
	.DB  0xF2,0xF2,0x0,0x0,0xF3,0xF3,0xF3,0xF3
	.DB  0x0,0x0,0xF5,0xF5,0xF5,0xF5,0x0,0x0
	.DB  0xF6,0xF6,0xF6,0xF6,0x0,0x0,0xF7,0xF7
	.DB  0xF7,0xF7,0x0,0x0,0xF8,0xF8,0xF8,0xF8
	.DB  0x0,0x0,0xFB,0xF9,0xFB,0xFA,0x1,0x1
	.DB  0xBB,0xBB,0xF4,0xF4,0x1,0x0
_GBGAND:
	.DB  0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80
_Defult:
	.DB  0x60,0x5,0x7,0x20,0x7E,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x5F,0x0,0x0,0x0
	.DB  0x7,0x0,0x7,0x0,0x14,0x7F,0x14,0x7F
	.DB  0x14,0x24,0x2A,0x7F,0x2A,0x12,0x23,0x13
	.DB  0x8,0x64,0x62,0x36,0x49,0x55,0x22,0x50
	.DB  0x0,0x5,0x3,0x0,0x0,0x0,0x1C,0x22
	.DB  0x41,0x0,0x0,0x41,0x22,0x1C,0x0,0x14
	.DB  0x8,0x3E,0x8,0x14,0x8,0x8,0x3E,0x8
	.DB  0x8,0x0,0x50,0x30,0x0,0x0,0x8,0x8
	.DB  0x8,0x8,0x8,0x0,0x60,0x60,0x0,0x0
	.DB  0x20,0x10,0x8,0x4,0x2,0x3E,0x51,0x49
	.DB  0x45,0x3E,0x0,0x42,0x7F,0x40,0x0,0x42
	.DB  0x61,0x51,0x49,0x46,0x21,0x41,0x45,0x4B
	.DB  0x31,0x18,0x14,0x12,0x7F,0x10,0x27,0x45
	.DB  0x45,0x45,0x39,0x3C,0x4A,0x49,0x49,0x30
	.DB  0x1,0x71,0x9,0x5,0x3,0x36,0x49,0x49
	.DB  0x49,0x36,0x6,0x49,0x49,0x29,0x1E,0x0
	.DB  0x36,0x36,0x0,0x0,0x0,0x56,0x36,0x0
	.DB  0x0,0x8,0x14,0x22,0x41,0x0,0x14,0x14
	.DB  0x14,0x14,0x14,0x0,0x41,0x22,0x14,0x8
	.DB  0x2,0x1,0x51,0x9,0x6,0x32,0x49,0x79
	.DB  0x41,0x3E,0x7E,0x11,0x11,0x11,0x7E,0x7F
	.DB  0x49,0x49,0x49,0x36,0x3E,0x41,0x41,0x41
	.DB  0x22,0x7F,0x41,0x41,0x22,0x1C,0x7F,0x49
	.DB  0x49,0x49,0x41,0x7F,0x9,0x9,0x9,0x1
	.DB  0x3E,0x41,0x49,0x49,0x7A,0x7F,0x8,0x8
	.DB  0x8,0x7F,0x0,0x41,0x7F,0x41,0x0,0x20
	.DB  0x40,0x41,0x3F,0x1,0x7F,0x8,0x14,0x22
	.DB  0x41,0x7F,0x40,0x40,0x40,0x40,0x7F,0x2
	.DB  0xC,0x2,0x7F,0x7F,0x4,0x8,0x10,0x7F
	.DB  0x3E,0x41,0x41,0x41,0x3E,0x7F,0x9,0x9
	.DB  0x9,0x6,0x3E,0x41,0x51,0x21,0x5E,0x7F
	.DB  0x9,0x19,0x29,0x46,0x46,0x49,0x49,0x49
	.DB  0x31,0x1,0x1,0x7F,0x1,0x1,0x3F,0x40
	.DB  0x40,0x40,0x3F,0x1F,0x20,0x40,0x20,0x1F
	.DB  0x3F,0x40,0x38,0x40,0x3F,0x63,0x14,0x8
	.DB  0x14,0x63,0x7,0x8,0x70,0x8,0x7,0x61
	.DB  0x51,0x49,0x45,0x43,0x0,0x7F,0x41,0x41
	.DB  0x0,0x2,0x4,0x8,0x10,0x20,0x0,0x41
	.DB  0x41,0x7F,0x0,0x4,0x2,0x1,0x2,0x4
	.DB  0x40,0x40,0x40,0x40,0x40,0x0,0x1,0x2
	.DB  0x4,0x0,0x20,0x54,0x54,0x54,0x78,0x7F
	.DB  0x48,0x44,0x44,0x38,0x38,0x44,0x44,0x44
	.DB  0x20,0x38,0x44,0x44,0x48,0x7F,0x38,0x54
	.DB  0x54,0x54,0x18,0x8,0x7E,0x9,0x1,0x2
	.DB  0xC,0x52,0x52,0x52,0x3E,0x7F,0x8,0x4
	.DB  0x4,0x78,0x0,0x44,0x7D,0x40,0x0,0x20
	.DB  0x40,0x44,0x3D,0x0,0x7F,0x10,0x28,0x44
	.DB  0x0,0x0,0x41,0x7F,0x40,0x0,0x7C,0x4
	.DB  0x18,0x4,0x78,0x7C,0x8,0x4,0x4,0x78
	.DB  0x38,0x44,0x44,0x44,0x38,0x7C,0x14,0x14
	.DB  0x14,0x8,0x8,0x14,0x14,0x18,0x7C,0x7C
	.DB  0x8,0x4,0x4,0x8,0x48,0x54,0x54,0x54
	.DB  0x20,0x4,0x3F,0x44,0x40,0x20,0x3C,0x40
	.DB  0x40,0x20,0x7C,0x1C,0x20,0x40,0x20,0x1C
	.DB  0x3C,0x40,0x30,0x40,0x3C,0x44,0x28,0x10
	.DB  0x28,0x44,0xC,0x50,0x50,0x50,0x3C,0x44
	.DB  0x64,0x54,0x4C,0x44,0x0,0x8,0x36,0x41
	.DB  0x0,0x0,0x0,0x7F,0x0,0x0,0x0,0x41
	.DB  0x36,0x8,0x0,0x10,0x8,0x8,0x10,0x8
	.DB  0x78,0x46,0x41,0x46,0x78

_0x27:
	.DB  0xC1
_0xB2:
	.DB  0x43,0x75,0x72,0x72,0x65,0x6E,0x74,0x20
	.DB  0x4C,0x69,0x6D,0x69,0x74,0x20,0x3A,0x0
	.DB  0x43,0x68,0x61,0x72,0x67,0x20,0x50,0x6F
	.DB  0x77,0x65,0x72,0x20,0x20,0x20,0x3A,0x0
	.DB  0x43,0x68,0x61,0x72,0x67,0x20,0x43,0x75
	.DB  0x72,0x72,0x65,0x6E,0x74,0x20,0x3A,0x0
	.DB  0x43,0x68,0x61,0x72,0x67,0x20,0x56,0x6F
	.DB  0x6C,0x74,0x61,0x67,0x65,0x20,0x3A,0x0
	.DB  0x43,0x68,0x61,0x72,0x67,0x20,0x4D,0x6F
	.DB  0x64,0x65,0x20,0x20,0x20,0x20,0x3A,0x0
	.DB  0x43,0x68,0x61,0x72,0x67,0x65,0x72,0x20
	.DB  0x53,0x74,0x61,0x74,0x75,0x73,0x0
_0xB9:
	.DB  0x42,0x61,0x74,0x74,0x72,0x79,0x20,0x56
	.DB  0x6F,0x6C,0x74,0x20,0x20,0x3A,0x0,0x42
	.DB  0x61,0x74,0x74,0x72,0x79,0x20,0x4C,0x65
	.DB  0x76,0x65,0x6C,0x20,0x3A,0x0,0x42,0x61
	.DB  0x74,0x74,0x72,0x79,0x20,0x53,0x74,0x61
	.DB  0x74,0x75,0x73,0x0
_0xEB:
	.DB  0x0,0x1C,0x0,0x0,0x0,0x0,0xA,0x1
_0x0:
	.DB  0x4F,0x46,0x46,0x0,0x46,0x6C,0x6F,0x61
	.DB  0x74,0x0,0x46,0x61,0x73,0x74,0x0,0x25
	.DB  0x2E,0x32,0x66,0x0,0x4F,0x4E,0x0,0x25
	.DB  0x2E,0x31,0x66,0x25,0x25,0x0,0x56,0x69
	.DB  0x65,0x77,0x20,0x43,0x48,0x20,0x25,0x69
	.DB  0x0,0x54,0x49,0x4D,0x45,0x2F,0x44,0x49
	.DB  0x56,0x20,0x3A,0x20,0x25,0x69,0x20,0x75
	.DB  0x53,0x0,0x43,0x75,0x72,0x72,0x65,0x6E
	.DB  0x74,0x20,0x6C,0x69,0x6D,0x69,0x74,0x65
	.DB  0x72,0x20,0x45,0x6E,0x61,0x62,0x6C,0x65
	.DB  0x25,0x63,0x0,0x43,0x75,0x72,0x72,0x65
	.DB  0x6E,0x74,0x20,0x6C,0x69,0x6D,0x69,0x74
	.DB  0x65,0x72,0x20,0x44,0x65,0x73,0x61,0x62
	.DB  0x6C,0x65,0x25,0x63,0x0
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x202005F:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _prevLet_G000
	.DW  _0x27*2

	.DW  0x08
	.DW  0x04
	.DW  _0xEB*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x202005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.4 Standard
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 2010-10-28
;Author  :
;Company :
;Comments:
;
;
;Chip type           : ATmega64
;Program type        : Application
;Clock frequency     : 4.000000 MHz
;Memory model        : Small
;External RAM size   : 0
;Data Stack size     : 1024
;*****************************************************/
;
;#include <mega64.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;
;// Standard Input/Output functions
;#include <stdio.h>
;#include "Driver\display.h"
;#ifndef _DISPLAY_C
;#define _DISPLAY_C
;
;
;#include <stdlib.h>
;#include <math.h>
;#ifndef outb
;    #define    outb(addr, data)    addr = (data)
;#endif
;#ifndef inb
;    #define    inb(addr)            (addr)
;#endif
;#ifndef BV
;    #define BV(bit)            (1<<(bit))
;#endif
;#ifndef cbi
;    #define cbi(reg,bit)    reg &= ~(BV(bit))
;#endif
;#ifndef sbi
;    #define sbi(reg,bit)    reg |= (BV(bit))
;#endif
;#ifndef cli
;    #define cli()            #asm cli #endasm
;#endif
;#ifndef sei
;    #define sei            #asm sei #endasm
;#endif
;
;
;
;
;#define FALSE	0
;#define TRUE	-1
;
;
;
;
;void InitHW(void)
; 0000 001C {

	.CSEG
_InitHW:
;
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFE)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFD)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFB)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS0);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFF7)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS1);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFEF)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS2);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFDF)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS3);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFBF)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_RESET);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFF7F)
	OUT  0x12,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_RS);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,1
	OUT  0x11,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_RW);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,2
	OUT  0x11,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_E);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,4
	OUT  0x11,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_CS0);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,8
	OUT  0x11,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_CS1);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,0x10
	OUT  0x11,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_CS2);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,0x20
	OUT  0x11,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_CS3);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,0x40
	OUT  0x11,R30
;    sbi(GLCD_CTRL_DDR, GLCD_CTRL_RESET);
	IN   R30,0x11
	LDI  R31,0
	ORI  R30,0x80
	OUT  0x11,R30
;    outb(GLCD_DATA_PORT, 0x00);
	LDI  R30,LOW(0)
	OUT  0x15,R30
;	outb(GLCD_DATA_DDR, 0xFF);
	LDI  R30,LOW(255)
	OUT  0x14,R30
;
;}
	RET
;
;void ControllerSelect(unsigned char controller)
;{
_ControllerSelect:
;
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS0);
;	controller -> Y+0
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFF7)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS1);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFEF)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS2);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFDF)
	OUT  0x12,R30
;    cbi(GLCD_CTRL_PORT, GLCD_CTRL_CS3);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFBF)
	OUT  0x12,R30
;
;
;    switch(controller)
	LD   R30,Y
	LDI  R31,0
;    {
;    case 0:    sbi(GLCD_CTRL_PORT, GLCD_CTRL_CS0); break;
	SBIW R30,0
	BRNE _0x6
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,8
	OUT  0x12,R30
	RJMP _0x5
;    case 1:    sbi(GLCD_CTRL_PORT, GLCD_CTRL_CS1); break;
_0x6:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x7
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,0x10
	OUT  0x12,R30
	RJMP _0x5
;	case 2:	sbi(GLCD_CTRL_PORT, GLCD_CTRL_CS2); break;
_0x7:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x8
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,0x20
	OUT  0x12,R30
	RJMP _0x5
;	case 3:	sbi(GLCD_CTRL_PORT, GLCD_CTRL_CS3); break;
_0x8:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0xA
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,0x40
	OUT  0x12,R30
;	default: break;
_0xA:
;	}
_0x5:
;
;}
	JMP  _0x20A000C
;
;void BusyWait(unsigned char controller)
;{
_BusyWait:
;    #asm
;	controller -> Y+0
	cli
;
;	ControllerSelect(controller);
	LD   R30,Y
	ST   -Y,R30
	RCALL _ControllerSelect
;	outb(GLCD_DATA_PORT, 0xFF);
	LDI  R30,LOW(255)
	OUT  0x15,R30
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFE)
	OUT  0x12,R30
;	outb(GLCD_DATA_DDR, 0x00);
	LDI  R30,LOW(0)
	OUT  0x14,R30
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,2
	OUT  0x12,R30
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,4
	OUT  0x12,R30
;	#asm
    nop
    nop
;	while(inb(GLCD_DATA_PIN) & GLCD_STATUS_BUSY)
_0xB:
	IN   R30,0x13
	LDI  R31,0
	ANDI R30,LOW(0x80)
	BREQ _0xD
;	{
;		cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFB)
	OUT  0x12,R30
;		#ifndef Speed_mode
;		#asm
;        nop
;        nop
;        #endasm
;		#endif
;		#asm
        nop
        nop
;		sbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,4
	OUT  0x12,R30
;		#ifndef Speed_mode
;		#asm
;        nop
;        nop
;        #endasm
;		#endif
;		#asm
        nop
        nop
;
;	}
	RJMP _0xB
_0xD:
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFB)
	OUT  0x12,R30
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFD)
	OUT  0x12,R30
;	outb(GLCD_DATA_DDR, 0xFF);
	LDI  R30,LOW(255)
	OUT  0x14,R30
;	 #asm
     sei
;}
	RJMP _0x20A000C
;
;
;void ControlWrite(unsigned char controller, unsigned char data)
;{
_ControlWrite:
;
;	#asm
;	controller -> Y+1
;	data -> Y+0
    cli
;	BusyWait(controller);
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _BusyWait
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFE)
	OUT  0x12,R30
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFD)
	OUT  0x12,R30
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,4
	OUT  0x12,R30
;	outb(GLCD_DATA_DDR, 0xFF);
	LDI  R30,LOW(255)
	OUT  0x14,R30
;	outb(GLCD_DATA_PORT, data);
	LD   R30,Y
	OUT  0x15,R30
;	#ifndef Speed_mode
;	#asm
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    #endasm
;	#endif
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFB)
	OUT  0x12,R30
;	#asm
    sei
;}
	RJMP _0x20A000B
;
;unsigned char ControlRead(unsigned char controller)
;{
;	register unsigned char data;
;
;	#asm
;	controller -> Y+1
;	data -> R17
;	BusyWait(controller);
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);
;	outb(GLCD_DATA_DDR, 0x00);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
;	#ifndef Speed_mode
;	#asm
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    #endasm
;	#endif
;	#asm
;	data = inb(GLCD_DATA_PIN);
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
;	outb(GLCD_DATA_DDR, 0xFF);
;	#asm
;
;
;	return data;
;}
;
;void Write(unsigned char data)
;{
_Write:
;	register unsigned char controller = (GrLcdState.lcdXAddr/GLCD_CONTROLLER_XPIXELS);
;
;	#asm
	ST   -Y,R17
;	data -> Y+1
;	controller -> R17
	LDS  R30,_GrLcdState_G000
	LDI  R31,0
	MOVW R26,R30
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	CALL __DIVW21
	MOV  R17,R30
    cli
;	BusyWait(controller);
	ST   -Y,R17
	CALL _BusyWait
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,1
	OUT  0x12,R30
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFD)
	OUT  0x12,R30
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,4
	OUT  0x12,R30
;	outb(GLCD_DATA_DDR, 0xFF);
	LDI  R30,LOW(255)
	OUT  0x14,R30
;	outb(GLCD_DATA_PORT, data);
	LDD  R30,Y+1
	OUT  0x15,R30
;	#ifndef Speed_mode
;	#asm
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    #endasm
;	#endif
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFFFB)
	OUT  0x12,R30
;	#asm
    sei
;
;
;	GrLcdState.ctrlr[controller].xAddr++;
	__POINTW2MN _GrLcdState_G000,2
	MOV  R30,R17
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
;	GrLcdState.lcdXAddr++;
	LDS  R30,_GrLcdState_G000
	SUBI R30,-LOW(1)
	STS  _GrLcdState_G000,R30
;	if(GrLcdState.lcdXAddr >= GLCD_XPIXELS)
	LDS  R26,_GrLcdState_G000
	CPI  R26,LOW(0x80)
	BRLO _0xE
;	{
;		GrLcdState.lcdYAddr++;
	__GETB1MN _GrLcdState_G000,1
	SUBI R30,-LOW(1)
	__PUTB1MN _GrLcdState_G000,1
	SUBI R30,LOW(1)
;		SetYAddress(GrLcdState.lcdYAddr);
	__GETB1MN _GrLcdState_G000,1
	ST   -Y,R30
	RCALL _SetYAddress
;		SetXAddress(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _SetXAddress
;	}
;}
_0xE:
	LDD  R17,Y+0
	RJMP _0x20A000B
;
;void SetXAddress(unsigned char xAddr)
;{
_SetXAddress:
;	unsigned char i;
;
;	GrLcdState.lcdXAddr = xAddr;
	ST   -Y,R17
;	xAddr -> Y+1
;	i -> R17
	LDD  R30,Y+1
	STS  _GrLcdState_G000,R30
;
;
;	for(i=0; i<GLCD_NUM_CONTROLLERS; i++)
	LDI  R17,LOW(0)
_0x10:
	CPI  R17,2
	BRSH _0x11
;	{
;		ControlWrite(i, GLCD_SET_Y_ADDR | 0x00);
	ST   -Y,R17
	LDI  R30,LOW(64)
	ST   -Y,R30
	RCALL _ControlWrite
;		GrLcdState.ctrlr[i].xAddr = 0;
	__POINTW2MN _GrLcdState_G000,2
	MOV  R30,R17
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;	}
	SUBI R17,-1
	RJMP _0x10
_0x11:
;
;
;	ControlWrite((GrLcdState.lcdXAddr/GLCD_CONTROLLER_XPIXELS),
;		GLCD_SET_Y_ADDR | (GrLcdState.lcdXAddr & 0x3F));
	LDS  R30,_GrLcdState_G000
	LDI  R31,0
	MOVW R22,R30
	MOVW R26,R30
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	CALL __DIVW21
	ST   -Y,R30
	MOVW R30,R22
	ANDI R30,LOW(0x3F)
	ANDI R31,HIGH(0x3F)
	ORI  R30,0x40
	ST   -Y,R30
	RCALL _ControlWrite
;}
	LDD  R17,Y+0
	RJMP _0x20A000B
;
;void SetYAddress(unsigned char yAddr)
;{
_SetYAddress:
;	unsigned char i;
;
;	GrLcdState.lcdYAddr = yAddr;
	ST   -Y,R17
;	yAddr -> Y+1
;	i -> R17
	LDD  R30,Y+1
	__PUTB1MN _GrLcdState_G000,1
;
;	for(i=0; i<GLCD_NUM_CONTROLLERS; i++)
	LDI  R17,LOW(0)
_0x13:
	CPI  R17,2
	BRSH _0x14
;	{
;		ControlWrite(i, GLCD_SET_PAGE | yAddr);
	ST   -Y,R17
	LDD  R30,Y+2
	LDI  R31,0
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	RCALL _ControlWrite
;	}
	SUBI R17,-1
	RJMP _0x13
_0x14:
;}
	LDD  R17,Y+0
	RJMP _0x20A000B
;
;unsigned char Read(void)
;{
;	register unsigned char data;
;	register unsigned char controller = (GrLcdState.lcdXAddr/GLCD_CONTROLLER_XPIXELS);
;
;	#asm
;	data -> R17
;	controller -> R16
;	BusyWait(controller);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);
;	outb(GLCD_DATA_DDR, 0x00);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
;	#ifndef Speed_mode
;	#asm
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    #endasm
;	#endif
;	data = inb(GLCD_DATA_PIN);
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
;
;
;	BusyWait(controller);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);
;	outb(GLCD_DATA_DDR, 0x00);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
;	sbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
;	#ifndef Speed_mode
;	#asm
;    nop
;    nop
;    nop
;    nop
;    nop
;    nop
;    #endasm
;	#endif
;	#asm
;
;	data = inb(GLCD_DATA_PIN);
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_E);
;	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW);
;	#asm
;
;
;	GrLcdState.ctrlr[controller].xAddr++;
;	GrLcdState.lcdXAddr++;
;	if(GrLcdState.lcdXAddr >= GLCD_XPIXELS)
;	{
;		GrLcdState.lcdYAddr++;
;		SetYAddress(GrLcdState.lcdYAddr);
;		SetXAddress(0);
;	}
;	return data;
;}
;
;
;void Reset(unsigned char resetState)
;{
_Reset:
;
;
;	if(resetState)
;	resetState -> Y+0
	LD   R30,Y
	CPI  R30,0
	BREQ _0x16
;		cbi(GLCD_CTRL_PORT, GLCD_CTRL_RESET);
	IN   R30,0x12
	LDI  R31,0
	ANDI R30,LOW(0xFF7F)
	RJMP _0xE2
;	else
_0x16:
;		sbi(GLCD_CTRL_PORT, GLCD_CTRL_RESET);
	IN   R30,0x12
	LDI  R31,0
	ORI  R30,0x80
_0xE2:
	OUT  0x12,R30
;
;}
	RJMP _0x20A000C
;
;void Init()
;{
_Init:
;	unsigned char i;
;
;
;	InitHW();
	ST   -Y,R17
;	i -> R17
	CALL _InitHW
;
;
;	Reset(FALSE);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _Reset
;
;	for(i=0; i<GLCD_NUM_CONTROLLERS; i++)
	LDI  R17,LOW(0)
_0x19:
	CPI  R17,2
	BRSH _0x1A
;	{
;		ControlWrite(i, GLCD_ON_CTRL | GLCD_ON_DISPLAY);
	ST   -Y,R17
	LDI  R30,LOW(63)
	ST   -Y,R30
	CALL _ControlWrite
;	}
	SUBI R17,-1
	RJMP _0x19
_0x1A:
;
;	ClearScreen();
	RCALL _ClearScreen
;
;	Home();
	RCALL _Home
;}
	RJMP _0x20A000D
;
;void Home(void)
;{
_Home:
;	unsigned char i;
;
;	StartLine(0);
	ST   -Y,R17
;	i -> R17
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _StartLine
;	SetAddress(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _SetAddress
;
;	for(i=0; i<GLCD_NUM_CONTROLLERS; i++)
	LDI  R17,LOW(0)
_0x1C:
	CPI  R17,2
	BRSH _0x1D
;	{
;		GrLcdState.ctrlr[i].xAddr = 0;
	__POINTW2MN _GrLcdState_G000,2
	MOV  R30,R17
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;		GrLcdState.ctrlr[i].yAddr = 0;
	__POINTW2MN _GrLcdState_G000,2
	MOV  R30,R17
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LDI  R30,LOW(0)
	ST   X,R30
;	}
	SUBI R17,-1
	RJMP _0x1C
_0x1D:
;}
_0x20A000D:
	LD   R17,Y+
	RET
;
;void ClearScreen(void)
;{
_ClearScreen:
;	unsigned char pageAddr;
;	unsigned char xAddr;
;
;
;	for(pageAddr=0; pageAddr<(GLCD_YPIXELS>>3); pageAddr++)
	ST   -Y,R17
	ST   -Y,R16
;	pageAddr -> R17
;	xAddr -> R16
	LDI  R17,LOW(0)
_0x1F:
	CPI  R17,8
	BRSH _0x20
;	{
;
;		SetAddress(0, pageAddr);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _SetAddress
;
;		for(xAddr=0; xAddr<GLCD_XPIXELS; xAddr++)
	LDI  R16,LOW(0)
_0x22:
	CPI  R16,128
	BRSH _0x23
;		{
;			Write(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _Write
;		}
	SUBI R16,-1
	RJMP _0x22
_0x23:
;	}
	SUBI R17,-1
	RJMP _0x1F
_0x20:
;}
	RJMP _0x20A000A
;
;
;void StartLine(unsigned char start)
;{
_StartLine:
;	ControlWrite(0, GLCD_START_LINE | start);
;	start -> Y+0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDD  R30,Y+1
	LDI  R31,0
	ORI  R30,LOW(0xC0)
	ST   -Y,R30
	CALL _ControlWrite
;	ControlWrite(1, GLCD_START_LINE | start);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDD  R30,Y+1
	LDI  R31,0
	ORI  R30,LOW(0xC0)
	ST   -Y,R30
	CALL _ControlWrite
;}
	RJMP _0x20A000C
;
;void SetAddress(unsigned char x, unsigned char yLine)
;{
_SetAddress:
;
;	SetYAddress(yLine);
;	x -> Y+1
;	yLine -> Y+0
	LD   R30,Y
	ST   -Y,R30
	RCALL _SetYAddress
;	SetXAddress(x);
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _SetXAddress
;}
	RJMP _0x20A000B
;
;
;
;
;
;
;#endif
;void Show_Buf(char *Buf){
; 0000 001D void Show_Buf(char *Buf){
_Show_Buf:
; 0000 001E     int i;
; 0000 001F     SetAddress(0,0);
	ST   -Y,R17
	ST   -Y,R16
;	*Buf -> Y+2
;	i -> R16,R17
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _SetAddress
; 0000 0020     for(i=0;i<1024;i++)
	__GETWRN 16,17,0
_0x25:
	__CPWRN 16,17,1024
	BRGE _0x26
; 0000 0021         Write(*Buf++);
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X+
	STD  Y+2,R26
	STD  Y+2+1,R27
	ST   -Y,R30
	RCALL _Write
	__ADDWRN 16,17,1
	RJMP _0x25
_0x26:
; 0000 0022 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20A0007
;#include <GBUF.h>
;#ifndef GB_CLASS
;#define GB_CLASS
;
;//#include "defult.h"
;#include <string.h>
;flash unsigned char map[121][6] = {{243,248,247,246,1,1},{130,0,0,0,0,0},{131,0,0,0,0,0},{132,0,0,0,0,0},{133,0,0,0,0,0},{134,0,0,0,0,0},{135,0,0,0,0,0},{136,0,0,0,0,0},{137,0,0,0,0,0},{138,0,0,0,0,0},{139,0,0,0,0,0},{140,0,0,0,0,0},{7,8,7,8,1,1},{1,1,2,2,1,0},{143,0,0,0,0,0},{3,4,5,6,1,1},{145,0,0,0,0,0},{146,0,0,0,0,0},{147,0,0,0,0,0},{148,0,0,0,0,0},{149,0,0,0,0,0},{150,0,0,0,0,0},{151,0,0,0,0,0},{223,172,174,173,1,1},{153,0,0,0,0,0},{154,0,0,0,0,0},{155,0,0,0,0,0},{156,0,0,0,0,0},{157,0,0,0,0,0},{158,0,0,0,0,0},{159,0,0,0,0,0},{160,0,0,0,0,0},{161,0,0,0,0,0},{162,0,0,0,0,0},{163,0,0,0,0,0},{164,0,0,0,0,0},{165,0,0,0,0,0},{166,0,0,0,0,0},{167,0,0,0,0,0},{168,0,0,0,0,0},{169,0,0,0,0,0},{170,0,0,0,0,0},{171,0,0,0,0,0},{172,0,0,0,0,0},{173,0,0,0,0,0},{174,0,0,0,0,0},{175,0,0,0,0,0},{176,0,0,0,0,0},{177,0,0,0,0,0},{178,0,0,0,0,0},{179,0,0,0,0,0},{180,0,0,0,0,0},{181,0,0,0,0,0},{182,0,0,0,0,0},{183,0,0,0,0,0},{184,0,0,0,0,0},{185,0,0,0,0,0},{186,0,0,0,0,0},{187,0,0,0,0,0},{188,0,0,0,0,0},{189,0,0,0,0,0},{190,0,0,0,0,0},{191,0,0,0,0,0},{192,0,0,0,0,0},{193,193,193,193,0,0},{194,194,254,254,1,0},{195,195,129,129,1,0},{196,196,252,252,1,0},{197,197,197,197,1,1},{198,189,191,190,1,1},{199,199,192,192,1,0},{200,130,132,131,1,1},{201,201,253,253,1,0},{202,133,135,134,1,1},{203,136,138,137,1,1},{204,139,204,139,1,1},{205,140,205,140,1,1},{206,141,206,141,1,1},{207,207,142,142,1,0},{208,208,143,143,1,0},{209,209,144,144,1,0},{210,210,145,145,1,0},{211,146,148,147,1,1},{212,149,151,150,1,1},{213,152,154,153,1,1},{214,155,157,156,1,1},{215,215,215,215,0,0},{216,216,158,158,1,1},{217,217,159,159,1,1},{218,160,162,161,1,1},{219,163,165,164,1,1},{220,220,220,220,0,0},{221,166,168,167,1,1},{222,169,171,170,1,1},{223,172,174,173,1,1},{224,224,224,224,0,0},{225,175,177,176,1,1},{226,226,266,226,0,0},{227,178,180,179,1,1},{228,181,183,182,1,1},{229,184,186,185,1,1},{230,230,188,188,1,0},{231,231,231,231,0,0},{232,232,232,232,0,0},{233,233,233,233,0,0},{234,234,234,234,0,0},{235,235,235,235,0,0},{236,189,191,190,1,1},{237,189,191,190,1,1},{238,238,238,238,0,0},{239,239,239,239,0,0},{240,240,240,240,0,0},{241,241,241,241,0,0},{242,242,242,242,0,0},{243,243,243,243,0,0},{245,245,245,245,0,0},{246,246,246,246,0,0},{247,247,247,247,0,0},{248,248,248,248,0,0},{251,249,251,250,1,1},{187,187,244,244,1,0}};typedef struct _FontDescriptor{unsigned char SIZE_X;unsigned char SIZE_Y;unsigned char Start_ch;unsigned char End_ch;flash char *adr;}FontDescriptor;static int prevLet = 193;static char stat = 0;static char prevX = 0;static char prevY = 0;FontDescriptor GBFont;flash char GBGAND[]={1,2,4,8,16,32,64,128};char _RTL = LTR;void GBSET_RTL(char Posion){if(Posion==LTR)_RTL=LTR;  else  _RTL=RTL;}void GBload_font(flash char *font){GBFont.SIZE_X =font[1];GBFont.SIZE_Y =font[2];GBFont.Start_ch=font[3];GBFont.End_ch=font[4];GBFont.adr =font;}unsigned char GBget_font(unsigned int adr){return GBFont.adr[5+adr];}char GBRead(char x, char y){x=(_RTL==LTR) ? x:MAX_X-x;return gbuf[x+y*MAX_X];}void GBWrite(char x, char y, char data){ x=(_RTL==LTR) ? x:MAX_X-x;gbuf[x+y*MAX_X]=data;}void GBGWrite(char x, char y,char _bit ,char data){char j;for(j=0;j<_bit;j++){if((data&GBGAND[j]) != 0) GBpset(x,y+j);  else  GBReset(x,y+j);}}void GBcls(void){int i;for(i=0; i<MAX_BUF ; i++)gbuf[i]=0;}void GBupdate(void){Show_Buf(gbuf);}void GBpset(char x,char y){int temp;x=(_RTL==LTR) ? x:MAX_X-x;temp = x+(y/8)*MAX_X;gbuf[temp]=gbuf[temp] | (GBGAND[(y % 8)]);}void GBReset(char x,char y){int temp;x=(_RTL==LTR) ? x:MAX_X-x;temp = x+(y/8)*MAX_X;gbuf[temp]=gbuf[temp] & ~(GBGAND[(y % 8)]);}void GBline(int startx,int starty,int endx,int endy,char color){register int t,distance;int xerr=0,yerr=0,deltax,deltay;int incx,incy;deltax=endx-startx;deltay=endy-starty;if (deltax>0)incx=1; else  if(deltax==0)incx=0; else incx=-1;if (deltay>0)incy=1; else  if(deltay==0)incy=0; else incy=-1;deltax=abs(deltax);deltay=abs(deltay);if (deltax>deltay)distance=deltax; else distance=deltay;for (t=0;t<distance+1;t++){if(color==0) GBReset(startx,starty); else GBpset(startx,starty);xerr +=deltax;yerr +=deltay;if(xerr>distance){xerr -=distance;startx +=incx;}if(yerr>distance){yerr -=distance;starty +=incy;}}}void GBCircle(unsigned char xcenter,unsigned char ycenter,unsigned char radius){int tswitch, y, x = 0;unsigned char d;d = ycenter - xcenter;y = radius;tswitch = 3 - 2 * radius;while (x <= y) {GBpset(xcenter + x, ycenter + y);     GBpset(xcenter + x, ycenter - y);GBpset(xcenter - x, ycenter + y);     GBpset(xcenter - x, ycenter - y);GBpset(ycenter + y - d, ycenter + x); GBpset(ycenter + y - d, ycenter - x);GBpset(ycenter - y - d, ycenter + x); GBpset(ycenter - y - d, ycenter - x);if (tswitch < 0) tswitch += (4 * x + 6); else  {tswitch += (4 * (x - y) + 10);y--;}x++;}}void GBputchar(unsigned char x, unsigned char y, char ch){unsigned char temp;unsigned char i;for(i=0;i<GBFont.SIZE_X;i++){temp=GBget_font(i+((ch-GBFont.Start_ch)*GBFont.SIZE_X));GBGWrite(x+i,y,GBFont.SIZE_Y,temp);}}void GBPputchar(char x,char y,char c){if((map[prevLet-129][5]) && (map[c-129][4]) && (c >= 129) && (prevLet >= 129)){GBputchar(prevX,prevY,map[prevLet-129][stat+1]);stat = 2;} else  stat = 0;if(c >= 129) GBputchar(x,y,map[c-129][stat]); else  GBputchar(x,y,c);prevLet = c;prevX = x;prevY = y;}void GBputs(unsigned char x, unsigned char y, char *st){char *temp,i=0;temp=st;while(*temp!=0){GBputchar(x+i,y,*temp);i+=GBFont.SIZE_X+1;temp++;}}void GBPputs(char x,char y,char *c){ char i = 0;char special = 0;x= MAX_X - 8 - x;while(i<strlen(c)){if((*(c+i) == 225) && (*(c+i+1) == 199))special = 249; else  if((*(c+i) == 225) && (*(c+i+1) == 195))special = 231; else  if((*(c+i) == 225) && (*(c+i+1) == 194))special = 232; else  if((*(c+i) == 225) && (*(c+i+1) == 197))special = 233;if(special){GBPputchar(x,y,special);i+=2;x -= 8;special = 0;continue;}GBPputchar(x,y,*(c+i));x -= 8;if(x < 0){x=120;y++;}i++;}prevLet = 193;}void GBputsf (unsigned char x, unsigned char y,unsigned int len ,char *st){char *temp,i=0;temp=st;while(*temp!=0 && len--!=0){GBputchar(x+i,y,*temp);i+=GBFont.SIZE_X+1;temp++;}}void GBFputs(unsigned char x, unsigned char y,char *st){char a=*st;if(a>=129)GBPputs(x,y,st); else GBputs(x,y,st);}void GBbox(int startx,int starty,int endx,int endy,char color){GBline(startx,starty,startx,endy+1,color);GBline(startx,starty,endx,starty,color);GBline(startx,endy+1,endx+1,endy+1,color);GBline(endx,starty,endx,endy+1,color);}void GBfill_box(int startx,int starty,int endx,int endy,char color){int i=0,j=0;if(starty>endy){i=endy;endy=starty;starty=i;}if(startx>endx){i=endx;endx=startx;startx=i;}for(i=startx;i<=endx;i++){for(j=starty;j<=endy;j++){if(color==0) GBReset(i,j); else  GBpset(i,j);}}}void GBfull_str(int x,int y,int len,char *st,char inv){unsigned char temp;char *stt;int u=0;unsigned char i,j,ch;stt=st;    while(*stt!=0 && len--!=0){   ch=*stt++;     for(i=0;i<GBFont.SIZE_X;i++){temp=GBget_font(i+((ch-GBFont.Start_ch)*GBFont.SIZE_X));if(inv!=0)temp=~temp;for(j=0;j<GBFont.SIZE_Y;j++)if((temp)&(1<<j))   GBpset(x+i+u,y+j); else GBReset(x+i+u,y+j);}for(j=0;j<GBFont.SIZE_Y;j++)if(inv!=0)GBpset(x+GBFont.SIZE_X+u,y+j); else GBReset(x+GBFont.SIZE_X+u,y+j);u+=GBFont.SIZE_X+1;}}

	.DSEG
; 0000 0023 flash unsigned char map[121][6] = {{243,248,247,246,1,1},{130,0,0,0,0,0},{131,0,0,0,0,0},{132,0,0,0,0,0},{133,0,0,0,0,0},{134,0,0,0,0,0},{135,0,0,0,0,0},{136,0,0,0,0,0},{137,0,0,0,0,0},{138,0,0,0,0,0},{139,0,0,0,0,0},{140,0,0,0,0,0},{7,8,7,8,1,1},{1,1,2,2,1,0},{143,0,0,0,0,0},{3,4,5,6,1,1},{145,0,0,0,0,0},{146,0,0,0,0,0},{147,0,0,0,0,0},{148,0,0,0,0,0},{149,0,0,0,0,0},{150,0,0,0,0,0},{151,0,0,0,0,0},{223,172,174,173,1,1},{153,0,0,0,0,0},{154,0,0,0,0,0},{155,0,0,0,0,0},{156,0,0,0,0,0},{157,0,0,0,0,0},{158,0,0,0,0,0},{159,0,0,0,0,0},{160,0,0,0,0,0},{161,0,0,0,0,0},{162,0,0,0,0,0},{163,0,0,0,0,0},{164,0,0,0,0,0},{165,0,0,0,0,0},{166,0,0,0,0,0},{167,0,0,0,0,0},{168,0,0,0,0,0},{169,0,0,0,0,0},{170,0,0,0,0,0},{171,0,0,0,0,0},{172,0,0,0,0,0},{173,0,0,0,0,0},{174,0,0,0,0,0},{175,0,0,0,0,0},{176,0,0,0,0,0},{177,0,0,0,0,0},{178,0,0,0,0,0},{179,0,0,0,0,0},{180,0,0,0,0,0},{181,0,0,0,0,0},{182,0,0,0,0,0},{183,0,0,0,0,0},{184,0,0,0,0,0},{185,0,0,0,0,0},{186,0,0,0,0,0},{187,0,0,0,0,0},{188,0,0,0,0,0},{189,0,0,0,0,0},{190,0,0,0,0,0},{191,0,0,0,0,0},{192,0,0,0,0,0},{193,193,193,193,0,0},{194,194,254,254,1,0},{195,195,129,129,1,0},{196,196,252,252,1,0},{197,197,197,197,1,1},{198,189,191,190,1,1},{199,199,192,192,1,0},{200,130,132,131,1,1},{201,201,253,253,1,0},{202,133,135,134,1,1},{203,136,138,137,1,1},{204,139,204,139,1,1},{205,140,205,140,1,1},{206,141,206,141,1,1},{207,207,142,142,1,0},{208,208,143,143,1,0},{209,209,144,144,1,0},{210,210,145,145,1,0},{211,146,148,147,1,1},{212,149,151,150,1,1},{213,152,154,153,1,1},{214,155,157,156,1,1},{215,215,215,215,0,0},{216,216,158,158,1,1},{217,217,159,159,1,1},{218,160,162,161,1,1},{219,163,165,164,1,1},{220,220,220,220,0,0},{221,166,168,167,1,1},{222,169,171,170,1,1},{223,172,174,173,1,1},{224,224,224,224,0,0},{225,175,177,176,1,1},{226,226,266,226,0,0},{227,178,180,179,1,1},{228,181,183,182,1,1},{229,184,186,185,1,1},{230,230,188,188,1,0},{231,231,231,231,0,0},{232,232,232,232,0,0},{233,233,233,233,0,0},{234,234,234,234,0,0},{235,235,235,235,0,0},{236,189,191,190,1,1},{237,189,191,190,1,1},{238,238,238,238,0,0},{239,239,239,239,0,0},{240,240,240,240,0,0},{241,241,241,241,0,0},{242,242,242,242,0,0},{243,243,243,243,0,0},{245,245,245,245,0,0},{246,246,246,246,0,0},{247,247,247,247,0,0},{248,248,248,248,0,0},{251,249,251,250,1,1},{187,187,244,244,1,0}};typedef struct _FontDescriptor{unsigned char SIZE_X;unsigned char SIZE_Y;unsigned char Start_ch;unsigned char End_ch;flash char *adr;}FontDescriptor;static int prevLet = 193;static char stat = 0;static char prevX = 0;static char prevY = 0;FontDescriptor GBFont;flash char GBGAND[]={1,2,4,8,16,32,64,128};char _RTL = 0x1C;void GBSET_RTL(char Posion){if(Posion==0x1C)_RTL=0x1C;  else  _RTL=~0x1C;}void GBload_font(flash char *font){GBFont.SIZE_X =font[1];GBFont.SIZE_Y =font[2];GBFont.Start_ch=font[3];GBFont.End_ch=font[4];GBFont.adr =font;}unsigned char GBget_font(unsigned int adr){return GBFont.adr[5+adr];}char GBRead(char x, char y){x=(_RTL==0x1C) ? x:128-x;return gbuf[x+y*128];}void GBWrite(char x, char y, char data){ x=(_RTL==0x1C) ? x:128-x;gbuf[x+y*128]=data;}void GBGWrite(char x, char y,char _bit ,char data){char j;for(j=0;j<_bit;j++){if((data&GBGAND[j]) != 0) GBpset(x,y+j);  else  GBReset(x,y+j);}}void GBcls(void){int i;for(i=0; i<128*64/8 ; i++)gbuf[i]=0;}void GBupdate(void){Show_Buf(gbuf);}void GBpset(char x,char y){int temp;x=(_RTL==0x1C) ? x:128-x;temp = x+(y/8)*128;gbuf[temp]=gbuf[temp] | (GBGAND[(y % 8)]);}void GBReset(char x,char y){int temp;x=(_RTL==0x1C) ? x:128-x;temp = x+(y/8)*128;gbuf[temp]=gbuf[temp] & ~(GBGAND[(y % 8)]);}void GBline(int startx,int starty,int endx,int endy,char color){register int t,distance;int xerr=0,yerr=0,deltax,deltay;int incx,incy;deltax=endx-startx;deltay=endy-starty;if (deltax>0)incx=1; else  if(deltax==0)incx=0; else incx=-1;if (deltay>0)incy=1; else  if(deltay==0)incy=0; else incy=-1;deltax=abs(deltax);deltay=abs(deltay);if (deltax>deltay)distance=deltax; else distance=deltay;for (t=0;t<distance+1;t++){if(color==0) GBReset(startx,starty); else GBpset(startx,starty);xerr +=deltax;yerr +=deltay;if(xerr>distance){xerr -=distance;startx +=incx;}if(yerr>distance){yerr -=distance;starty +=incy;}}}void GBCircle(unsigned char xcenter,unsigned char ycenter,unsigned char radius){int tswitch, y, x = 0;unsigned char d;d = ycenter - xcenter;y = radius;tswitch = 3 - 2 * radius;while (x <= y) {GBpset(xcenter + x, ycenter + y);     GBpset(xcenter + x, ycenter - y);GBpset(xcenter - x, ycenter + y);     GBpset(xcenter - x, ycenter - y);GBpset(ycenter + y - d, ycenter + x); GBpset(ycenter + y - d, ycenter - x);GBpset(ycenter - y - d, ycenter + x); GBpset(ycenter - y - d, ycenter - x);if (tswitch < 0) tswitch += (4 * x + 6); else  {tswitch += (4 * (x - y) + 10);y--;}x++;}}void GBputchar(unsigned char x, unsigned char y, char ch){unsigned char temp;unsigned char i;for(i=0;i<GBFont.SIZE_X;i++){temp=GBget_font(i+((ch-GBFont.Start_ch)*GBFont.SIZE_X));GBGWrite(x+i,y,GBFont.SIZE_Y,temp);}}void GBPputchar(char x,char y,char c){if((map[prevLet-129][5]) && (map[c-129][4]) && (c >= 129) && (prevLet >= 129)){GBputchar(prevX,prevY,map[prevLet-129][stat+1]);stat = 2;} else  stat = 0;if(c >= 129) GBputchar(x,y,map[c-129][stat]); else  GBputchar(x,y,c);prevLet = c;prevX = x;prevY = y;}void GBputs(unsigned char x, unsigned char y, char *st){char *temp,i=0;temp=st;while(*temp!=0){GBputchar(x+i,y,*temp);i+=GBFont.SIZE_X+1;temp++;}}void GBPputs(char x,char y,char *c){ char i = 0;char special = 0;x= 128 - 8 - x;while(i<strlen(c)){if((*(c+i) == 225) && (*(c+i+1) == 199))special = 249; else  if((*(c+i) == 225) && (*(c+i+1) == 195))special = 231; else  if((*(c+i) == 225) && (*(c+i+1) == 194))special = 232; else  if((*(c+i) == 225) && (*(c+i+1) == 197))special = 233;if(special){GBPputchar(x,y,special);i+=2;x -= 8;special = 0;continue;}GBPputchar(x,y,*(c+i));x -= 8;if(x < 0){x=120;y++;}i++;}prevLet = 193;}void GBputsf (unsigned char x, unsigned char y,unsigned int len ,char *st){char *temp,i=0;temp=st;while(*temp!=0 && len--!=0){GBputchar(x+i,y,*temp);i+=GBFont.SIZE_X+1;temp++;}}void GBFputs(unsigned char x, unsigned char y,char *st){char a=*st;if(a>=129)GBPputs(x,y,st); else GBputs(x,y,st);}void GBbox(int startx,int starty,int endx,int endy,char color){GBline(startx,starty,startx,endy+1,color);GBline(startx,starty,endx,starty,color);GBline(startx,endy+1,endx+1,endy+1,color);GBline(endx,starty,endx,endy+1,color);}void GBfill_box(int startx,int starty,int endx,int endy,char color){int i=0,j=0;if(starty>endy){i=endy;endy=starty;starty=i;}if(startx>endx){i=endx;endx=startx;startx=i;}for(i=startx;i<=endx;i++){for(j=starty;j<=endy;j++){if(color==0) GBReset(i,j); else  GBpset(i,j);}}}void GBfull_str(int x,int y,int len,char *st,char inv){unsigned char temp;char *stt;int u=0;unsigned char i,j,ch;stt=st;    while(*stt!=0 && len--!=0){   ch=*stt++;     for(i=0;i<GBFont.SIZE_X;i++){temp=GBget_font(i+((ch-GBFont.Start_ch)*GBFont.SIZE_X));if(inv!=0)temp=~temp;for(j=0;j<GBFont.SIZE_Y;j++)if((temp)&(1<<j))   GBpset(x+i+u,y+j); else GBReset(x+i+u,y+j);}for(j=0;j<GBFont.SIZE_Y;j++)if(inv!=0)GBpset(x+GBFont.SIZE_X+u,y+j); else GBReset(x+GBFont.SIZE_X+u,y+j);u+=GBFont.SIZE_X+1;}}

	.CSEG
_GBSET_RTL:
;	Posion -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x1C)
	BRNE _0x28
	LDI  R30,LOW(28)
	RJMP _0xE3
_0x28:
	LDI  R30,LOW(65507)
_0xE3:
	MOV  R5,R30
_0x20A000C:
	ADIW R28,1
	RET
_GBload_font:
;	*font -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	LPM  R0,Z
	STS  _GBFont,R0
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,2
	LPM  R0,Z
	__PUTBR0MN _GBFont,1
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,3
	LPM  R0,Z
	__PUTBR0MN _GBFont,2
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,4
	LPM  R0,Z
	__PUTBR0MN _GBFont,3
	LD   R30,Y
	LDD  R31,Y+1
	__PUTW1MN _GBFont,4
	RJMP _0x20A000B
_GBget_font:
;	adr -> Y+0
	__GETW2MN _GBFont,4
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,5
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
_0x20A000B:
	ADIW R28,2
	RET
;	x -> Y+1
;	y -> Y+0
;	x -> Y+2
;	y -> Y+1
;	data -> Y+0
_GBGWrite:
	ST   -Y,R17
;	x -> Y+4
;	y -> Y+3
;	_bit -> Y+2
;	data -> Y+1
;	j -> R17
	LDI  R17,LOW(0)
_0x31:
	LDD  R30,Y+2
	CP   R17,R30
	BRSH _0x32
	LDD  R26,Y+1
	CLR  R27
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_GBGAND*2)
	SBCI R31,HIGH(-_GBGAND*2)
	LPM  R30,Z
	LDI  R31,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x33
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R26,Y+4
	CLR  R27
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	RCALL _GBpset
	RJMP _0x34
_0x33:
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R26,Y+4
	CLR  R27
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	RCALL _GBReset
_0x34:
	SUBI R17,-1
	RJMP _0x31
_0x32:
	RJMP _0x20A0009
_GBcls:
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,0
_0x36:
	__CPWRN 16,17,1024
	BRGE _0x37
	LDI  R26,LOW(_gbuf)
	LDI  R27,HIGH(_gbuf)
	ADD  R26,R16
	ADC  R27,R17
	LDI  R30,LOW(0)
	ST   X,R30
	__ADDWRN 16,17,1
	RJMP _0x36
_0x37:
_0x20A000A:
	LD   R16,Y+
	LD   R17,Y+
	RET
_GBupdate:
	LDI  R30,LOW(_gbuf)
	LDI  R31,HIGH(_gbuf)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Show_Buf
	RET
_GBpset:
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+3
;	y -> Y+2
;	temp -> R16,R17
	LDI  R30,LOW(28)
	CP   R30,R5
	BRNE _0x38
	LDD  R30,Y+3
	RJMP _0x39
_0x38:
	LDD  R30,Y+3
	LDI  R31,0
	LDI  R26,LOW(128)
	LDI  R27,HIGH(128)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
_0x39:
	STD  Y+3,R30
	LDD  R22,Y+3
	CLR  R23
	LDD  R30,Y+2
	LDI  R31,0
	MOVW R26,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL __DIVW21
	CALL __LSLW3
	CALL __LSLW4
	ADD  R30,R22
	ADC  R31,R23
	MOVW R16,R30
	MOVW R30,R16
	SUBI R30,LOW(-_gbuf)
	SBCI R31,HIGH(-_gbuf)
	PUSH R31
	PUSH R30
	LDI  R26,LOW(_gbuf)
	LDI  R27,HIGH(_gbuf)
	ADD  R26,R16
	ADC  R27,R17
	LD   R22,X
	CLR  R23
	LDD  R26,Y+2
	CLR  R27
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL __MODW21
	SUBI R30,LOW(-_GBGAND*2)
	SBCI R31,HIGH(-_GBGAND*2)
	LPM  R30,Z
	LDI  R31,0
	OR   R30,R22
	OR   R31,R23
	POP  R26
	POP  R27
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20A0007
_GBReset:
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+3
;	y -> Y+2
;	temp -> R16,R17
	LDI  R30,LOW(28)
	CP   R30,R5
	BRNE _0x3B
	LDD  R30,Y+3
	RJMP _0x3C
_0x3B:
	LDD  R30,Y+3
	LDI  R31,0
	LDI  R26,LOW(128)
	LDI  R27,HIGH(128)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
_0x3C:
	STD  Y+3,R30
	LDD  R22,Y+3
	CLR  R23
	LDD  R30,Y+2
	LDI  R31,0
	MOVW R26,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL __DIVW21
	CALL __LSLW3
	CALL __LSLW4
	ADD  R30,R22
	ADC  R31,R23
	MOVW R16,R30
	MOVW R30,R16
	SUBI R30,LOW(-_gbuf)
	SBCI R31,HIGH(-_gbuf)
	PUSH R31
	PUSH R30
	LDI  R26,LOW(_gbuf)
	LDI  R27,HIGH(_gbuf)
	ADD  R26,R16
	ADC  R27,R17
	LD   R22,X
	CLR  R23
	LDD  R26,Y+2
	CLR  R27
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL __MODW21
	SUBI R30,LOW(-_GBGAND*2)
	SBCI R31,HIGH(-_GBGAND*2)
	LPM  R30,Z
	COM  R30
	LDI  R31,0
	AND  R30,R22
	AND  R31,R23
	POP  R26
	POP  R27
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20A0007
_GBline:
	SBIW R28,10
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+9,R30
	CALL __SAVELOCR6
;	startx -> Y+23
;	starty -> Y+21
;	endx -> Y+19
;	endy -> Y+17
;	color -> Y+16
;	t -> R16,R17
;	distance -> R18,R19
;	xerr -> R20,R21
;	yerr -> Y+14
;	deltax -> Y+12
;	deltay -> Y+10
;	incx -> Y+8
;	incy -> Y+6
	__GETWRN 20,21,0
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __CPW02
	BRGE _0x3E
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xE4
_0x3E:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0x40
	LDI  R30,0
	STD  Y+8,R30
	STD  Y+8+1,R30
	RJMP _0x41
_0x40:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0xE4:
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x41:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CALL __CPW02
	BRGE _0x42
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xE5
_0x42:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BRNE _0x44
	LDI  R30,0
	STD  Y+6,R30
	STD  Y+6+1,R30
	RJMP _0x45
_0x44:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0xE5:
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x45:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x46
	__GETWRS 18,19,12
	RJMP _0x47
_0x46:
	__GETWRS 18,19,10
_0x47:
	__GETWRN 16,17,0
_0x49:
	MOVW R30,R18
	ADIW R30,1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x4A
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x4B
	LDD  R30,Y+23
	ST   -Y,R30
	LDD  R30,Y+22
	ST   -Y,R30
	RCALL _GBReset
	RJMP _0x4C
_0x4B:
	LDD  R30,Y+23
	ST   -Y,R30
	LDD  R30,Y+22
	ST   -Y,R30
	RCALL _GBpset
_0x4C:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	__ADDWRR 20,21,30,31
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+14,R30
	STD  Y+14+1,R31
	__CPWRR 18,19,20,21
	BRGE _0x4D
	__SUBWRR 20,21,18,19
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+23,R30
	STD  Y+23+1,R31
_0x4D:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CP   R18,R26
	CPC  R19,R27
	BRGE _0x4E
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+21,R30
	STD  Y+21+1,R31
_0x4E:
	__ADDWRN 16,17,1
	RJMP _0x49
_0x4A:
	CALL __LOADLOCR6
	ADIW R28,25
	RET
;	xcenter -> Y+9
;	ycenter -> Y+8
;	radius -> Y+7
;	tswitch -> R16,R17
;	y -> R18,R19
;	x -> R20,R21
;	d -> Y+6
_GBputchar:
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+4
;	y -> Y+3
;	ch -> Y+2
;	temp -> R17
;	i -> R16
	LDI  R16,LOW(0)
_0x55:
	LDS  R30,_GBFont
	CP   R16,R30
	BRSH _0x56
	MOV  R22,R16
	CLR  R23
	LDD  R26,Y+2
	CLR  R27
	__GETB1MN _GBFont,2
	LDI  R31,0
	SUB  R26,R30
	SBC  R27,R31
	LDS  R30,_GBFont
	LDI  R31,0
	CALL __MULW12
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBget_font
	MOV  R17,R30
	LDD  R26,Y+4
	CLR  R27
	MOV  R30,R16
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	__GETB1MN _GBFont,1
	ST   -Y,R30
	ST   -Y,R17
	RCALL _GBGWrite
	SUBI R16,-1
	RJMP _0x55
_0x56:
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20A0008
_GBPputchar:
;	x -> Y+2
;	y -> Y+1
;	c -> Y+0
	LDS  R30,_prevLet_G000
	LDS  R31,_prevLet_G000+1
	SUBI R30,LOW(129)
	SBCI R31,HIGH(129)
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	SUBI R30,LOW(-_map*2)
	SBCI R31,HIGH(-_map*2)
	ADIW R30,5
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x58
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(129)
	SBCI R31,HIGH(129)
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	SUBI R30,LOW(-_map*2)
	SBCI R31,HIGH(-_map*2)
	ADIW R30,4
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x58
	LD   R26,Y
	CPI  R26,LOW(0x81)
	BRLO _0x58
	LDS  R26,_prevLet_G000
	LDS  R27,_prevLet_G000+1
	CPI  R26,LOW(0x81)
	LDI  R30,HIGH(0x81)
	CPC  R27,R30
	BRGE _0x59
_0x58:
	RJMP _0x57
_0x59:
	LDS  R30,_prevX_G000
	ST   -Y,R30
	LDS  R30,_prevY_G000
	ST   -Y,R30
	LDS  R30,_prevLet_G000
	LDS  R31,_prevLet_G000+1
	SUBI R30,LOW(129)
	SBCI R31,HIGH(129)
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	SUBI R30,LOW(-_map*2)
	SBCI R31,HIGH(-_map*2)
	MOVW R26,R30
	LDS  R30,_stat_G000
	LDI  R31,0
	ADIW R30,1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	ST   -Y,R30
	RCALL _GBputchar
	LDI  R30,LOW(2)
	RJMP _0xE6
_0x57:
	LDI  R30,LOW(0)
_0xE6:
	STS  _stat_G000,R30
	LD   R26,Y
	CPI  R26,LOW(0x81)
	BRLO _0x5B
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	LDI  R31,0
	SUBI R30,LOW(129)
	SBCI R31,HIGH(129)
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12U
	SUBI R30,LOW(-_map*2)
	SBCI R31,HIGH(-_map*2)
	MOVW R26,R30
	LDS  R30,_stat_G000
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RJMP _0xE7
_0x5B:
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
_0xE7:
	ST   -Y,R30
	RCALL _GBputchar
	LD   R30,Y
	LDI  R31,0
	STS  _prevLet_G000,R30
	STS  _prevLet_G000+1,R31
	LDD  R30,Y+2
	STS  _prevX_G000,R30
	LDD  R30,Y+1
	STS  _prevY_G000,R30
	ADIW R28,3
	RET
_GBputs:
	CALL __SAVELOCR4
;	x -> Y+7
;	y -> Y+6
;	*st -> Y+4
;	*temp -> R16,R17
;	i -> R19
	LDI  R19,0
	__GETWRS 16,17,4
_0x5D:
	MOVW R26,R16
	LD   R30,X
	CPI  R30,0
	BREQ _0x5F
	LDD  R26,Y+7
	CLR  R27
	MOV  R30,R19
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	LDD  R30,Y+7
	ST   -Y,R30
	MOVW R26,R16
	LD   R30,X
	ST   -Y,R30
	RCALL _GBputchar
	MOV  R26,R19
	CLR  R27
	LDS  R30,_GBFont
	LDI  R31,0
	ADIW R30,1
	ADD  R30,R26
	MOV  R19,R30
	__ADDWRN 16,17,1
	RJMP _0x5D
_0x5F:
	CALL __LOADLOCR4
	ADIW R28,8
	RET
_GBPputs:
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+5
;	y -> Y+4
;	*c -> Y+2
;	i -> R17
;	special -> R16
	LDI  R17,0
	LDI  R16,0
	LDD  R30,Y+5
	LDI  R31,0
	LDI  R26,LOW(120)
	LDI  R27,HIGH(120)
	CALL __SWAPW12
	SUB  R30,R26
	STD  Y+5,R30
_0x60:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R26,R17
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRLO PC+3
	JMP _0x62
	MOV  R30,R17
	LDI  R31,0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xE1)
	BRNE _0x64
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	CPI  R30,LOW(0xC7)
	BREQ _0x65
_0x64:
	RJMP _0x63
_0x65:
	LDI  R16,LOW(249)
	RJMP _0x66
_0x63:
	MOV  R30,R17
	LDI  R31,0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xE1)
	BRNE _0x68
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	CPI  R30,LOW(0xC3)
	BREQ _0x69
_0x68:
	RJMP _0x67
_0x69:
	LDI  R16,LOW(231)
	RJMP _0x6A
_0x67:
	MOV  R30,R17
	LDI  R31,0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xE1)
	BRNE _0x6C
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	CPI  R30,LOW(0xC2)
	BREQ _0x6D
_0x6C:
	RJMP _0x6B
_0x6D:
	LDI  R16,LOW(232)
	RJMP _0x6E
_0x6B:
	MOV  R30,R17
	LDI  R31,0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xE1)
	BRNE _0x70
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	CPI  R30,LOW(0xC5)
	BREQ _0x71
_0x70:
	RJMP _0x6F
_0x71:
	LDI  R16,LOW(233)
_0x6F:
_0x6E:
_0x6A:
_0x66:
	CPI  R16,0
	BREQ _0x72
	LDD  R30,Y+5
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	ST   -Y,R16
	RCALL _GBPputchar
	MOV  R30,R17
	LDI  R31,0
	ADIW R30,2
	MOV  R17,R30
	LDD  R30,Y+5
	LDI  R31,0
	SBIW R30,8
	STD  Y+5,R30
	LDI  R16,LOW(0)
	RJMP _0x60
_0x72:
	LDD  R30,Y+5
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	MOV  R30,R17
	LDI  R31,0
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	RCALL _GBPputchar
	LDD  R30,Y+5
	LDI  R31,0
	SBIW R30,8
	STD  Y+5,R30
	LDD  R26,Y+5
	SUBI R17,-1
	RJMP _0x60
_0x62:
	LDI  R30,LOW(193)
	LDI  R31,HIGH(193)
	STS  _prevLet_G000,R30
	STS  _prevLet_G000+1,R31
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,6
	RET
;	x -> Y+9
;	y -> Y+8
;	len -> Y+6
;	*st -> Y+4
;	*temp -> R16,R17
;	i -> R19
_GBFputs:
	ST   -Y,R17
;	x -> Y+4
;	y -> Y+3
;	*st -> Y+1
;	a -> R17
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	MOV  R17,R30
	CPI  R17,129
	BRLO _0x79
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBPputs
	RJMP _0x7A
_0x79:
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBputs
_0x7A:
_0x20A0009:
	LDD  R17,Y+0
_0x20A0008:
	ADIW R28,5
	RET
_GBbox:
;	startx -> Y+7
;	starty -> Y+5
;	endx -> Y+3
;	endy -> Y+1
;	color -> Y+0
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _GBline
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _GBline
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _GBline
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _GBline
	ADIW R28,9
	RET
_GBfill_box:
	CALL __SAVELOCR4
;	startx -> Y+11
;	starty -> Y+9
;	endx -> Y+7
;	endy -> Y+5
;	color -> Y+4
;	i -> R16,R17
;	j -> R18,R19
	__GETWRN 16,17,0
	__GETWRN 18,19,0
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x7B
	__GETWRS 16,17,5
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	STD  Y+5,R30
	STD  Y+5+1,R31
	__PUTWSR 16,17,9
_0x7B:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x7C
	__GETWRS 16,17,7
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	STD  Y+7,R30
	STD  Y+7+1,R31
	__PUTWSR 16,17,11
_0x7C:
	__GETWRS 16,17,11
_0x7E:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x7F
	__GETWRS 18,19,9
_0x81:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x82
	LDD  R30,Y+4
	CPI  R30,0
	BRNE _0x83
	ST   -Y,R16
	ST   -Y,R18
	RCALL _GBReset
	RJMP _0x84
_0x83:
	ST   -Y,R16
	ST   -Y,R18
	RCALL _GBpset
_0x84:
	__ADDWRN 18,19,1
	RJMP _0x81
_0x82:
	__ADDWRN 16,17,1
	RJMP _0x7E
_0x7F:
	CALL __LOADLOCR4
	ADIW R28,13
	RET
_GBfull_str:
	SBIW R28,2
	CALL __SAVELOCR6
;	x -> Y+15
;	y -> Y+13
;	len -> Y+11
;	*st -> Y+9
;	inv -> Y+8
;	temp -> R17
;	*stt -> R18,R19
;	u -> R20,R21
;	i -> R16
;	j -> Y+7
;	ch -> Y+6
	__GETWRN 20,21,0
	__GETWRS 18,19,9
_0x85:
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x0)
	BREQ _0x88
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	SBIW R26,1
	STD  Y+11,R26
	STD  Y+11+1,R27
	ADIW R26,1
	SBIW R26,0
	BRNE _0x89
_0x88:
	RJMP _0x87
_0x89:
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	STD  Y+6,R30
	LDI  R16,LOW(0)
_0x8B:
	LDS  R30,_GBFont
	CP   R16,R30
	BRLO PC+3
	JMP _0x8C
	MOV  R22,R16
	CLR  R23
	LDD  R26,Y+6
	CLR  R27
	__GETB1MN _GBFont,2
	LDI  R31,0
	SUB  R26,R30
	SBC  R27,R31
	LDS  R30,_GBFont
	LDI  R31,0
	CALL __MULW12
	ADD  R30,R22
	ADC  R31,R23
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBget_font
	MOV  R17,R30
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x8D
	COM  R17
_0x8D:
	LDI  R30,LOW(0)
	STD  Y+7,R30
_0x8F:
	__GETB1MN _GBFont,1
	LDD  R26,Y+7
	CP   R26,R30
	BRSH _0x90
	MOV  R22,R17
	CLR  R23
	LDD  R30,Y+7
	LDI  R26,LOW(1)
	CALL __LSLB12
	LDI  R31,0
	AND  R30,R22
	AND  R31,R23
	SBIW R30,0
	BREQ _0x91
	MOV  R30,R16
	LDI  R31,0
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	ADD  R30,R26
	ADC  R31,R27
	ADD  R30,R20
	ADC  R31,R21
	ST   -Y,R30
	LDD  R30,Y+8
	LDI  R31,0
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	RCALL _GBpset
	RJMP _0x92
_0x91:
	MOV  R30,R16
	LDI  R31,0
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	ADD  R30,R26
	ADC  R31,R27
	ADD  R30,R20
	ADC  R31,R21
	ST   -Y,R30
	LDD  R30,Y+8
	LDI  R31,0
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	RCALL _GBReset
_0x92:
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	STD  Y+7,R30
	RJMP _0x8F
_0x90:
	SUBI R16,-1
	RJMP _0x8B
_0x8C:
	LDI  R30,LOW(0)
	STD  Y+7,R30
_0x94:
	__GETB1MN _GBFont,1
	LDD  R26,Y+7
	CP   R26,R30
	BRSH _0x95
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x96
	LDS  R30,_GBFont
	LDI  R31,0
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	ADD  R30,R26
	ADC  R31,R27
	ADD  R30,R20
	ADC  R31,R21
	ST   -Y,R30
	LDD  R30,Y+8
	LDI  R31,0
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	RCALL _GBpset
	RJMP _0x97
_0x96:
	LDS  R30,_GBFont
	LDI  R31,0
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	ADD  R30,R26
	ADC  R31,R27
	ADD  R30,R20
	ADC  R31,R21
	ST   -Y,R30
	LDD  R30,Y+8
	LDI  R31,0
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R30
	RCALL _GBReset
_0x97:
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	STD  Y+7,R30
	RJMP _0x94
_0x95:
	LDS  R30,_GBFont
	LDI  R31,0
	ADIW R30,1
	__ADDWRR 20,21,30,31
	RJMP _0x85
_0x87:
	CALL __LOADLOCR6
	ADIW R28,17
	RET
;#endif
;#include "Defult.h"
;#include <delay.h>
;
;#include "charger.c"
;//
;
;#define Battry_CELL 6   //12V
;
;#define NSHENT  read_adc10bit(7)
;#define VSHENT  NSHENT*0.004883
;#define ISHENT  NSHENT*0.028722
;
;#define NBUT    read_adc10bit(6)
;#define VBUT    NBUT*0.004883
;
;#define NNBUT   (NBUT-NSHENT)
;#define VVBUT   NNBUT*0.024414
;
;#define ADC_VREF_TYPE_10 0x00
;// Read the AD conversion result
;unsigned int read_adc10bit(unsigned char adc_input)
; 0000 0027 {
_read_adc10bit:
;ADMUX=ADC_VREF_TYPE_10 & 0xff; //SET BIT RATE
;	adc_input -> Y+0
	LDI  R30,LOW(0)
	OUT  0x7,R30
;ADMUX=adc_input | (ADC_VREF_TYPE_10 & 0xff);
	LD   R30,Y
	LDI  R31,0
	OUT  0x7,R30
;// Delay needed for the stabilization of the ADC input voltage
;delay_us(10);
	__DELAY_USB 27
;// Start the AD conversion
;ADCSRA|=0x40;
	IN   R30,0x6
	LDI  R31,0
	ORI  R30,0x40
	OUT  0x6,R30
;// Wait for the AD conversion to complete
;while ((ADCSRA & 0x10)==0);
_0x98:
	IN   R30,0x6
	LDI  R31,0
	ANDI R30,LOW(0x10)
	BREQ _0x98
;ADCSRA|=0x10;
	IN   R30,0x6
	LDI  R31,0
	ORI  R30,0x10
	OUT  0x6,R30
;return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	JMP  _0x20A0006
;}
;
;
;#define Float   PORTB.0
;#define Fast    PORTB.1
;#define Shutdown    PORTB.2
;#define Limit   PORTB.3
;
; float VBATTRY;
;float get_status(void){
_get_status:
;
; float stat;
;
; Shutdown=1;
	SBIW R28,4
;	stat -> Y+0
	SBI  0x18,2
; VBATTRY=VVBUT;
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _read_adc10bit
	PUSH R31
	PUSH R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _read_adc10bit
	POP  R26
	POP  R27
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x3CC7FFDE
	CALL __MULF12
	STS  _VBATTRY,R30
	STS  _VBATTRY+1,R31
	STS  _VBATTRY+2,R22
	STS  _VBATTRY+3,R23
; stat = (VBATTRY-11.9)/0.75*100;
	LDS  R26,_VBATTRY
	LDS  R27,_VBATTRY+1
	LDS  R24,_VBATTRY+2
	LDS  R25,_VBATTRY+3
	__GETD1N 0x413E6666
	CALL __SWAPD12
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3F400000
	CALL __DIVF21
	__GETD2N 0x42C80000
	CALL __MULF12
	__PUTD1S 0
; if (stat<0) stat=10;
	LDD  R26,Y+3
	TST  R26
	BRPL _0x9D
	__GETD1N 0x41200000
	__PUTD1S 0
; if(PINE.5==1)
_0x9D:
	LDI  R26,0
	SBIC 0x1,5
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BRNE _0x9E
;    Shutdown=0;
	CBI  0x18,2
; return stat;
_0x9E:
	__GETD1S 0
	RJMP _0x20A0007
;}
;
;void set_charge_type(){
_set_charge_type:
;float s;
;
;    s=get_status();
	SBIW R28,4
;	s -> Y+0
	RCALL _get_status
	__PUTD1S 0
;    if(PINE.5==0)
	SBIS 0x1,5
;    return;
	RJMP _0x20A0007
;if(s>=95){
	__GETD2S 0
	__GETD1N 0x42BE0000
	CALL __CMPF12
	BRLO _0xA2
;    if(Float!=1)
	LDI  R26,0
	SBIC 0x18,0
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BREQ _0xA3
;    Float=1;Fast=0;
	SBI  0x18,0
_0xA3:
	CBI  0x18,1
; }else{
	RJMP _0xA8
_0xA2:
;    if(Fast!=1)
	LDI  R26,0
	SBIC 0x18,1
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BREQ _0xA9
;   Fast=1;Float=0;
	SBI  0x18,1
_0xA9:
	CBI  0x18,0
; }
_0xA8:
;}
_0x20A0007:
	ADIW R28,4
	RET
;
;char tukometr=0;
;
;// Timer 2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;{
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;if(tukometr++>=1){
	MOV  R30,R4
	INC  R4
	CPI  R30,LOW(0x1)
	BRLO _0xAE
;tukometr=0;
	CLR  R4
;set_charge_type();
	RCALL _set_charge_type
;}
;}
_0xAE:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;#include "VIEW.c"
;////// VIEW
;#define ADC_VREF_TYPE_8 0x20
;// Read the 8 most significant bits
;// of the AD conversion result
;unsigned char read_adc(unsigned char adc_input)
; 0000 0028 {
_read_adc:
;ADMUX=ADC_VREF_TYPE_8 & 0xff;
;	adc_input -> Y+0
	LDI  R30,LOW(32)
	OUT  0x7,R30
;ADMUX=adc_input | (ADC_VREF_TYPE_8 & 0xff);
	LD   R30,Y
	LDI  R31,0
	ORI  R30,0x20
	OUT  0x7,R30
;// Delay needed for the stabilization of the ADC input voltage
;delay_us(10);
	__DELAY_USB 27
;// Start the AD conversion
;ADCSRA|=0x40;
	IN   R30,0x6
	LDI  R31,0
	ORI  R30,0x40
	OUT  0x6,R30
;// Wait for the AD conversion to complete
;while ((ADCSRA & 0x10)==0);
_0xAF:
	IN   R30,0x6
	LDI  R31,0
	ANDI R30,LOW(0x10)
	BREQ _0xAF
;ADCSRA|=0x10;
	IN   R30,0x6
	LDI  R31,0
	ORI  R30,0x10
	OUT  0x6,R30
;return ADCH;
	IN   R30,0x5
	JMP  _0x20A0006
;}
;
;
;
;void Charger_Status(){
_Charger_Status:
;char title[]="Charger Status";
;char st1[] = "Charg Mode    :";
;char st2[] = "Charg Voltage :";
;char st3[] = "Charg Current :";
;char st4[] = "Charg Power   :";
;char st5[] = "Current Limit :";
;
;char t1[6];
;char t2[6];
;char t3[6];
;char t4[6];
;char t5[6];
;
;
;if(Shutdown==1)
	SBIW R28,63
	SBIW R28,62
	LDI  R24,95
	LDI  R26,LOW(30)
	LDI  R27,HIGH(30)
	LDI  R30,LOW(_0xB2*2)
	LDI  R31,HIGH(_0xB2*2)
	CALL __INITLOCB
;	title -> Y+110
;	st1 -> Y+94
;	st2 -> Y+78
;	st3 -> Y+62
;	st4 -> Y+46
;	st5 -> Y+30
;	t1 -> Y+24
;	t2 -> Y+18
;	t3 -> Y+12
;	t4 -> Y+6
;	t5 -> Y+0
	LDI  R26,0
	SBIC 0x18,2
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BRNE _0xB3
;        sprintf(t1,"OFF");
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	RJMP _0xE8
;else
_0xB3:
;        if(Float==1)
	LDI  R26,0
	SBIC 0x18,0
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BRNE _0xB5
;        sprintf(t1,"Float");
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,4
	RJMP _0xE8
;        else
_0xB5:
;        sprintf(t1,"Fast");
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,10
_0xE8:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;sprintf(t3,"%.2f",ISHENT);
	MOVW R30,R28
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,15
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _read_adc10bit
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x3CEB4A66
	CALL __MULF12
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;sprintf(t2,"%.2f",VVBUT);
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,15
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _read_adc10bit
	PUSH R31
	PUSH R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _read_adc10bit
	POP  R26
	POP  R27
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x3CC7FFDE
	CALL __MULF12
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;sprintf(t4,"%.2f",VVBUT*ISHENT);
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,15
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _read_adc10bit
	PUSH R31
	PUSH R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _read_adc10bit
	POP  R26
	POP  R27
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x3CC7FFDE
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _read_adc10bit
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __MULF12
	__GETD2N 0x3CEB4A66
	CALL __MULF12
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;if(Limit==1)
	LDI  R26,0
	SBIC 0x18,3
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BRNE _0xB7
;        sprintf(t5,"ON");
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,20
	RJMP _0xE9
;else
_0xB7:
;        sprintf(t5,"OFF");
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
_0xE9:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
;GBcls();
	RCALL _GBcls
;GBFputs(2,2,title);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(112))
	SBCI R31,HIGH(-(112))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBbox(0,0,127,62,black);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(62)
	LDI  R31,HIGH(62)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBbox
;GBline(0,10,127,10,black);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBline
;GBFputs(4,12+1,st1);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(96))
	SBCI R31,HIGH(-(96))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(4,20+2,st2);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(22)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(80))
	SBCI R31,HIGH(-(80))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(4,28+3,st3);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(64))
	SBCI R31,HIGH(-(64))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(4,36+4,st4);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,48
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(4,44+5,st5);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(49)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;
;GBFputs(95,12+1,t1);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(95,20+2,t2);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(22)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,20
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(95,28+3,t3);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(31)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,14
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(95,36+4,t4);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(40)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBFputs(95,44+5,t5);
	LDI  R30,LOW(95)
	ST   -Y,R30
	LDI  R30,LOW(49)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBupdate();
	RCALL _GBupdate
;
;}
	ADIW R28,63
	ADIW R28,62
	RET
;
;
;void battry_status(){
_battry_status:
;
;char title[]="Battry Status";
;char st1[]="Battry Level :";
;char st2[]="Battry Volt  :";
;float stat;
;float volt=VBATTRY;
;
;
;stat = (VBATTRY-11.9)/0.75*100;
	SBIW R28,52
	LDI  R24,44
	LDI  R26,LOW(8)
	LDI  R27,HIGH(8)
	LDI  R30,LOW(_0xB9*2)
	LDI  R31,HIGH(_0xB9*2)
	CALL __INITLOCB
;	title -> Y+38
;	st1 -> Y+23
;	st2 -> Y+8
;	stat -> Y+4
;	volt -> Y+0
	LDS  R30,_VBATTRY
	LDS  R31,_VBATTRY+1
	LDS  R22,_VBATTRY+2
	LDS  R23,_VBATTRY+3
	__PUTD1S 0
	LDS  R26,_VBATTRY
	LDS  R27,_VBATTRY+1
	LDS  R24,_VBATTRY+2
	LDS  R25,_VBATTRY+3
	__GETD1N 0x413E6666
	CALL __SWAPD12
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3F400000
	CALL __DIVF21
	__GETD2N 0x42C80000
	CALL __MULF12
	__PUTD1S 4
; if (stat<0) stat=0;
	LDD  R26,Y+7
	TST  R26
	BRPL _0xBA
	__CLRD1S 4
; if(stat>100) stat = 100;
_0xBA:
	__GETD2S 4
	__GETD1N 0x42C80000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0xBB
	__PUTD1S 4
;
;
;GBcls();
_0xBB:
	RCALL _GBcls
;GBFputs(2,2,title);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,40
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBbox(0,0,127,62,black);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(62)
	LDI  R31,HIGH(62)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBbox
;GBline(0,10,127,10,black);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBline
;
;GBbox(30,20-5,90,35-5,black);
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBbox
;GBbox(90,20+5-5,96,35-5-5,black);
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(96)
	LDI  R31,HIGH(96)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(25)
	LDI  R31,HIGH(25)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBbox
;GBfill_box(32,22-5,32+(56*stat/100),34-5,black);
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 8
	__GETD2N 0x42600000
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x42C80000
	CALL __DIVF21
	__GETD2N 0x42000000
	CALL __ADDF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(29)
	LDI  R31,HIGH(29)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBfill_box
;
;GBfill_box(2,38,125,61,black);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(38)
	LDI  R31,HIGH(38)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(125)
	LDI  R31,HIGH(125)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(61)
	LDI  R31,HIGH(61)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBfill_box
;GBfull_str(10,41,20,st1,1);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(41)
	LDI  R31,HIGH(41)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBfull_str
;sprintf(st1,"%.1f%%",stat);
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,23
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 8
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;GBfull_str(93,41,10,st1,1);
	LDI  R30,LOW(93)
	LDI  R31,HIGH(93)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(41)
	LDI  R31,HIGH(41)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBfull_str
;GBfull_str(10,51,20,st2,1);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(51)
	LDI  R31,HIGH(51)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,14
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBfull_str
;sprintf(st1,"%.2f", volt);
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,15
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 4
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;GBfull_str(93,51,10,st1,1);
	LDI  R30,LOW(93)
	LDI  R31,HIGH(93)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(51)
	LDI  R31,HIGH(51)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBfull_str
;
;GBupdate();
	RCALL _GBupdate
;
;}
	ADIW R28,52
	RET
;
;int _delay;
;char ch=0;
;char TM_EN=0;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;{
_timer0_ovf_isr:
	ST   -Y,R30
;
;
;TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;
;}
	LD   R30,Y+
	RETI
;
;
;void Drow_ch(char chanal,unsigned int delay){
_Drow_ch:
;
;char title[];
;char st1[20];
;char sample[128];
;int y;
;char i;
;
;_delay=delay;
	SBIW R28,63
	SBIW R28,63
	SBIW R28,22
	CALL __SAVELOCR4
;	chanal -> Y+154
;	delay -> Y+152
;	title -> Y+152
;	st1 -> Y+132
;	sample -> Y+4
;	y -> R16,R17
;	i -> R19
	__GETWRSX 6,7,152
;GBcls();
	RCALL _GBcls
;ch=chanal;
	__GETBRSX 9,154
;sprintf(title,"View CH %i",chanal+1) ;
	MOVW R30,R28
	SUBI R30,LOW(-(152))
	SBCI R31,HIGH(-(152))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,30
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 158
	LDI  R31,0
	ADIW R30,1
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;GBFputs(2,2,title);
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(154))
	SBCI R31,HIGH(-(154))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;GBbox(0,0,127,62,black);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(62)
	LDI  R31,HIGH(62)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBbox
;GBline(0,10,127,10,black);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBline
;sprintf(st1,"TIME/DIV : %i uS",_delay+30);
	MOVW R30,R28
	SUBI R30,LOW(-(132))
	SBCI R31,HIGH(-(132))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,41
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R6
	ADIW R30,30
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
;GBFputs(2,14,st1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(14)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(134))
	SBCI R31,HIGH(-(134))
	ST   -Y,R31
	ST   -Y,R30
	RCALL _GBFputs
;
;GBbox(2,23,125,60,black);
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(23)
	LDI  R31,HIGH(23)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(125)
	LDI  R31,HIGH(125)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _GBbox
;//GBfill_box(3,24,124,60,white);
;for(i=2;i<126;i++){
	LDI  R19,LOW(2)
_0xBD:
	CPI  R19,126
	BRSH _0xBE
; sample[i]= read_adc(ch);
	MOV  R30,R19
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	ST   -Y,R9
	RCALL _read_adc
	POP  R26
	POP  R27
	ST   X,R30
; y=_delay;
	MOVW R16,R6
; while(y--!=0)
_0xBF:
	MOVW R30,R16
	__SUBWRN 16,17,1
	SBIW R30,0
	BREQ _0xC1
; delay_us(1);
	__DELAY_USB 3
	RJMP _0xBF
_0xC1:
	SUBI R19,-1
	RJMP _0xBD
_0xBE:
; for(i=3;i<126;i++)
	LDI  R19,LOW(3)
_0xC3:
	CPI  R19,126
	BRLO PC+3
	JMP _0xC4
;        GBline(i-1,25+(sample[i-1]*(0.125)),i,25+(sample[i]*(0.125)),black);
	MOV  R26,R19
	LDI  R27,0
	SBIW R26,1
	ST   -Y,R27
	ST   -Y,R26
	MOV  R26,R19
	LDI  R27,0
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3E000000
	CALL __MULF12
	__GETD2N 0x41C80000
	CALL __ADDF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,10
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LDI  R31,0
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3E000000
	CALL __MULF12
	__GETD2N 0x41C80000
	CALL __ADDF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _GBline
	SUBI R19,-1
	RJMP _0xC3
_0xC4:
	CALL _GBupdate
;
;
;}
	CALL __LOADLOCR4
	ADIW R28,63
	ADIW R28,63
	ADIW R28,29
	RET
;
;
;void MCU_INIT(void){
_MCU_INIT:
;// USART0 initialization
;// Communication Parameters: 8 Data, 1 Stop, No Parity
;// USART0 Receiver: On
;// USART0 Transmitter: On
;// USART0 Mode: Asynchronous
;// USART0 Baud Rate: 9600
;UCSR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;UCSR0B=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
;UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;UBRR0L=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;
; PORTA=255;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
; PORTG=255;
	STS  101,R30
;// ADC initialization
;// ADC Clock frequency: 1000.000 kHz
;// ADC Voltage Reference: AREF pin
;ADMUX=ADC_VREF_TYPE_8 & 0xff;
	LDI  R30,LOW(32)
	OUT  0x7,R30
;ADCSRA=0x82;
	LDI  R30,LOW(130)
	OUT  0x6,R30
;
;// Timer(s)/Counter(s) Interrupt(s) initialization
;TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x37,R30
;ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
;
;// External Interrupt(s) initialization
;// INT0: Off
;// INT1: Off
;// INT2: Off
;// INT3: Off
;// INT4: On
;// INT4 Mode: Falling Edge
;// INT5: On
;// INT5 Mode: Any change
;// INT6: Off
;// INT7: Off
;EICRA=0x00;
	STS  106,R30
;EICRB=0x06;
	LDI  R30,LOW(6)
	OUT  0x3A,R30
;EIMSK=0x30;
	LDI  R30,LOW(48)
	OUT  0x39,R30
;EIFR=0x30;
	OUT  0x38,R30
;
;// Timer/Counter 2 initialization
;// Clock source: System Clock
;// Clock value: 7.813 kHz
;// Mode: Normal top=FFh
;// OC2 output: Disconnected
;TCCR2=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
;TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;OCR2=0x00;
	OUT  0x23,R30
;
;DDRB=255;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;Float=1;
	SBI  0x18,0
;Limit=1;
	SBI  0x18,3
;if(PINE.5==0)
	SBIS 0x1,5
;   Shutdown=1;
	SBI  0x18,2
;
;Init();
	CALL _Init
;
;GBload_font(Defult);  //          
	LDI  R30,LOW(_Defult*2)
	LDI  R31,HIGH(_Defult*2)
	ST   -Y,R31
	ST   -Y,R30
	CALL _GBload_font
;GBSET_RTL(LTR);         // Set RTL Or LTR Direction
	LDI  R30,LOW(28)
	ST   -Y,R30
	CALL _GBSET_RTL
;
;
;#asm("sei")
	sei
;}
	RET
;
;char job=1;
;char rate=10;
;// External Interrupt 0 service routine
;interrupt [EXT_INT4] void ext_int4_isr(void)
; 0000 002E {
_ext_int4_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 002F // Place your code here
; 0000 0030    job=~PINA;
	IN   R30,0x19
	COM  R30
	MOV  R11,R30
; 0000 0031    rate=(~PING)&0b00011111;
	LDS  R30,99
	COM  R30
	LDI  R31,0
	ANDI R30,LOW(0x1F)
	ANDI R31,HIGH(0x1F)
	MOV  R10,R30
; 0000 0032 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;interrupt [EXT_INT5] void ext_int5_isr(void)
; 0000 0035 {
_ext_int5_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
; 0000 0036      if(PINE.5==1)
	LDI  R26,0
	SBIC 0x1,5
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BRNE _0xCC
; 0000 0037         Shutdown=0;
	CBI  0x18,2
; 0000 0038     else
	RJMP _0xCF
_0xCC:
; 0000 0039         Shutdown=1;
	SBI  0x18,2
; 0000 003A }
_0xCF:
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;
;
;void main(void)
; 0000 003F {
_main:
; 0000 0040 
; 0000 0041 MCU_INIT();
	RCALL _MCU_INIT
; 0000 0042 
; 0000 0043 
; 0000 0044 
; 0000 0045 while (1)
_0xD2:
; 0000 0046       {
; 0000 0047       switch(job){
	MOV  R30,R11
	LDI  R31,0
; 0000 0048         case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xD8
; 0000 0049 
; 0000 004A                 Charger_Status();
	RCALL _Charger_Status
; 0000 004B                 break;
	RJMP _0xD7
; 0000 004C         case 2:
_0xD8:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xD9
; 0000 004D                 Drow_ch(0,rate*10);
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOV  R26,R10
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MULW12
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Drow_ch
; 0000 004E                 break;
	RJMP _0xD7
; 0000 004F         case 4:
_0xD9:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0xDA
; 0000 0050                Drow_ch(1,rate*10);
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOV  R26,R10
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MULW12
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Drow_ch
; 0000 0051                 break;
	RJMP _0xD7
; 0000 0052         case 8:
_0xDA:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xDB
; 0000 0053                 battry_status();
	RCALL _battry_status
; 0000 0054                 break;
	RJMP _0xD7
; 0000 0055         case 16:
_0xDB:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0xD7
; 0000 0056                 Limit=~Limit;
	SBIS 0x18,3
	RJMP _0xDD
	CBI  0x18,3
	RJMP _0xDE
_0xDD:
	SBI  0x18,3
_0xDE:
; 0000 0057            if(Limit==1)
	LDI  R26,0
	SBIC 0x18,3
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BRNE _0xDF
; 0000 0058                 printf("Current limiter Enable%c",13);
	__POINTW1FN _0x0,58
	RJMP _0xEA
; 0000 0059             else
_0xDF:
; 0000 005A                 printf("Current limiter Desable%c",13);
	__POINTW1FN _0x0,83
_0xEA:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0xD
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
; 0000 005B                 job=1;
	LDI  R30,LOW(1)
	MOV  R11,R30
; 0000 005C         break;
; 0000 005D         }
_0xD7:
; 0000 005E         //delay_ms(10);
; 0000 005F       };
	RJMP _0xD2
; 0000 0060 }
_0xE1:
	RJMP _0xE1
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
_0x20A0006:
	ADIW R28,1
	RET
__put_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x2000012:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x2000013:
	RJMP _0x2000014
_0x2000010:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x2000014:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__ftoe_G100:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	CALL __SAVELOCR4
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x2000018
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
	RJMP _0x20A0005
_0x2000018:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x2000017
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
	RJMP _0x20A0005
_0x2000017:
	LDD  R26,Y+11
	CPI  R26,LOW(0x7)
	BRLO _0x200001A
	LDI  R30,LOW(6)
	STD  Y+11,R30
_0x200001A:
	LDD  R17,Y+11
_0x200001B:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x200001D
	__GETD2S 4
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 4
	RJMP _0x200001B
_0x200001D:
	__GETD1S 12
	CALL __CPD10
	BRNE _0x200001E
	LDI  R19,LOW(0)
	__GETD2S 4
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 4
	RJMP _0x200001F
_0x200001E:
	LDD  R19,Y+11
	__GETD1S 4
	__GETD2S 12
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2000020
	__GETD2S 4
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 4
_0x2000021:
	__GETD1S 4
	__GETD2S 12
	CALL __CMPF12
	BRLO _0x2000023
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__PUTD1S 12
	SUBI R19,-LOW(1)
	RJMP _0x2000021
_0x2000023:
	RJMP _0x2000024
_0x2000020:
_0x2000025:
	__GETD1S 4
	__GETD2S 12
	CALL __CMPF12
	BRSH _0x2000027
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 12
	SUBI R19,LOW(1)
	RJMP _0x2000025
_0x2000027:
	__GETD2S 4
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 4
_0x2000024:
	__GETD1S 12
	__GETD2N 0x3F000000
	CALL __ADDF12
	__PUTD1S 12
	__GETD1S 4
	__GETD2S 12
	CALL __CMPF12
	BRLO _0x2000028
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__PUTD1S 12
	SUBI R19,-LOW(1)
_0x2000028:
_0x200001F:
	LDI  R17,LOW(0)
_0x2000029:
	LDD  R30,Y+11
	CP   R30,R17
	BRSH PC+3
	JMP _0x200002B
	__GETD2S 4
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _floor
	__PUTD1S 4
	__GETD2S 12
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	MOV  R30,R16
	LDI  R31,0
	ADIW R30,48
	ST   X,R30
	MOV  R30,R16
	CALL __CBD1
	CALL __CDF1
	__GETD2S 4
	CALL __MULF12
	__GETD2S 12
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 12
	MOV  R30,R17
	SUBI R17,-1
	CPI  R30,0
	BREQ _0x200002C
	RJMP _0x2000029
_0x200002C:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x2000029
_0x200002B:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	LDD  R26,Y+10
	STD  Z+0,R26
	CPI  R19,0
	BRGE _0x200002D
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	LDI  R30,LOW(45)
	ST   X,R30
	NEG  R19
_0x200002D:
	CPI  R19,10
	BRLT _0x200002E
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	MOVW R22,R30
	MOV  R26,R19
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	ADIW R30,48
	MOVW R26,R22
	ST   X,R30
_0x200002E:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	MOVW R22,R30
	MOV  R26,R19
	LDI  R27,0
	SBRC R26,7
	SER  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ADIW R30,48
	MOVW R26,R22
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20A0005:
	CALL __LOADLOCR4
	ADIW R28,16
	RET
__print_G100:
	SBIW R28,63
	SBIW R28,15
	CALL __SAVELOCR6
	LDI  R17,0
	__GETW1SX 84
	STD  Y+16,R30
	STD  Y+16+1,R31
_0x200002F:
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000031
	MOV  R30,R17
	LDI  R31,0
	SBIW R30,0
	BRNE _0x2000035
	CPI  R18,37
	BRNE _0x2000036
	LDI  R17,LOW(1)
	RJMP _0x2000037
_0x2000036:
	ST   -Y,R18
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
_0x2000037:
	RJMP _0x2000034
_0x2000035:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2000038
	CPI  R18,37
	BRNE _0x2000039
	ST   -Y,R18
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	RJMP _0x2000101
_0x2000039:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+19,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x200003A
	LDI  R16,LOW(1)
	RJMP _0x2000034
_0x200003A:
	CPI  R18,43
	BRNE _0x200003B
	LDI  R30,LOW(43)
	STD  Y+19,R30
	RJMP _0x2000034
_0x200003B:
	CPI  R18,32
	BRNE _0x200003C
	LDI  R30,LOW(32)
	STD  Y+19,R30
	RJMP _0x2000034
_0x200003C:
	RJMP _0x200003D
_0x2000038:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x200003E
_0x200003D:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x200003F
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	OR   R30,R26
	MOV  R16,R30
	RJMP _0x2000034
_0x200003F:
	RJMP _0x2000040
_0x200003E:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2000041
_0x2000040:
	CPI  R18,48
	BRLO _0x2000043
	CPI  R18,58
	BRLO _0x2000044
_0x2000043:
	RJMP _0x2000042
_0x2000044:
	MOV  R26,R21
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	MULS R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R22,R21
	CLR  R23
	MOV  R26,R18
	LDI  R27,0
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	ADD  R30,R26
	MOV  R21,R30
	RJMP _0x2000034
_0x2000042:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0x2000045
	LDI  R17,LOW(4)
	RJMP _0x2000034
_0x2000045:
	RJMP _0x2000046
_0x2000041:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x2000048
	CPI  R18,48
	BRLO _0x200004A
	CPI  R18,58
	BRLO _0x200004B
_0x200004A:
	RJMP _0x2000049
_0x200004B:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	OR   R30,R26
	MOV  R16,R30
	MOV  R26,R20
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	MULS R30,R26
	MOVW R30,R0
	MOV  R20,R30
	MOV  R22,R20
	CLR  R23
	MOV  R26,R18
	LDI  R27,0
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	ADD  R30,R26
	MOV  R20,R30
	RJMP _0x2000034
_0x2000049:
_0x2000046:
	CPI  R18,108
	BRNE _0x200004C
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	OR   R30,R26
	MOV  R16,R30
	LDI  R17,LOW(5)
	RJMP _0x2000034
_0x200004C:
	RJMP _0x200004D
_0x2000048:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2000034
_0x200004D:
	MOV  R30,R18
	LDI  R31,0
	CPI  R30,LOW(0x63)
	LDI  R26,HIGH(0x63)
	CPC  R31,R26
	BRNE _0x2000052
	__GETW1SX 88
	SBIW R30,4
	__PUTW1SX 88
	LDD  R26,Z+4
	ST   -Y,R26
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	RJMP _0x2000053
_0x2000052:
	CPI  R30,LOW(0x45)
	LDI  R26,HIGH(0x45)
	CPC  R31,R26
	BREQ _0x2000056
	CPI  R30,LOW(0x65)
	LDI  R26,HIGH(0x65)
	CPC  R31,R26
	BRNE _0x2000057
_0x2000056:
	RJMP _0x2000058
_0x2000057:
	CPI  R30,LOW(0x66)
	LDI  R26,HIGH(0x66)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2000059
_0x2000058:
	MOVW R30,R28
	ADIW R30,20
	STD  Y+10,R30
	STD  Y+10+1,R31
	__GETW2SX 88
	CALL __GETD1P
	__PUTD1S 6
	__GETW1SX 88
	SBIW R30,4
	__PUTW1SX 88
	LDD  R26,Y+9
	TST  R26
	BRMI _0x200005A
	LDD  R26,Y+19
	CPI  R26,LOW(0x2B)
	BREQ _0x200005C
	RJMP _0x200005D
_0x200005A:
	__GETD1S 6
	CALL __ANEGF1
	__PUTD1S 6
	LDI  R30,LOW(45)
	STD  Y+19,R30
_0x200005C:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200005E
	LDD  R30,Y+19
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	RJMP _0x200005F
_0x200005E:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	SBIW R30,1
	LDD  R26,Y+19
	STD  Z+0,R26
_0x200005F:
_0x200005D:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BRNE _0x2000060
	LDI  R20,LOW(6)
_0x2000060:
	CPI  R18,102
	BRNE _0x2000061
	__GETD1S 6
	CALL __PUTPARD1
	ST   -Y,R20
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
	RJMP _0x2000062
_0x2000061:
	__GETD1S 6
	CALL __PUTPARD1
	ST   -Y,R20
	ST   -Y,R18
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL __ftoe_G100
_0x2000062:
	MOVW R30,R28
	ADIW R30,20
	STD  Y+10,R30
	STD  Y+10+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000063
_0x2000059:
	CPI  R30,LOW(0x73)
	LDI  R26,HIGH(0x73)
	CPC  R31,R26
	BRNE _0x2000065
	__GETW1SX 88
	SBIW R30,4
	__PUTW1SX 88
	__GETW2SX 88
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000066
_0x2000065:
	CPI  R30,LOW(0x70)
	LDI  R26,HIGH(0x70)
	CPC  R31,R26
	BRNE _0x2000068
	__GETW1SX 88
	SBIW R30,4
	__PUTW1SX 88
	__GETW2SX 88
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	OR   R30,R26
	MOV  R16,R30
_0x2000066:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(65407)
	LDI  R31,HIGH(65407)
	AND  R30,R26
	MOV  R16,R30
	CPI  R20,0
	BREQ _0x200006A
	CP   R20,R17
	BRLO _0x200006B
_0x200006A:
	RJMP _0x2000069
_0x200006B:
	MOV  R17,R20
_0x2000069:
_0x2000063:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+18,R30
	LDI  R19,LOW(0)
	RJMP _0x200006C
_0x2000068:
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BREQ _0x200006F
	CPI  R30,LOW(0x69)
	LDI  R26,HIGH(0x69)
	CPC  R31,R26
	BRNE _0x2000070
_0x200006F:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	OR   R30,R26
	MOV  R16,R30
	RJMP _0x2000071
_0x2000070:
	CPI  R30,LOW(0x75)
	LDI  R26,HIGH(0x75)
	CPC  R31,R26
	BRNE _0x2000072
_0x2000071:
	LDI  R30,LOW(10)
	STD  Y+18,R30
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x2000073
	__GETD1N 0x3B9ACA00
	__PUTD1S 12
	LDI  R17,LOW(10)
	RJMP _0x2000074
_0x2000073:
	__GETD1N 0x2710
	__PUTD1S 12
	LDI  R17,LOW(5)
	RJMP _0x2000074
_0x2000072:
	CPI  R30,LOW(0x58)
	LDI  R26,HIGH(0x58)
	CPC  R31,R26
	BRNE _0x2000076
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	OR   R30,R26
	MOV  R16,R30
	RJMP _0x2000077
_0x2000076:
	CPI  R30,LOW(0x78)
	LDI  R26,HIGH(0x78)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x20000B5
_0x2000077:
	LDI  R30,LOW(16)
	STD  Y+18,R30
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x2000079
	__GETD1N 0x10000000
	__PUTD1S 12
	LDI  R17,LOW(8)
	RJMP _0x2000074
_0x2000079:
	__GETD1N 0x1000
	__PUTD1S 12
	LDI  R17,LOW(4)
_0x2000074:
	CPI  R20,0
	BREQ _0x200007A
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(65407)
	LDI  R31,HIGH(65407)
	AND  R30,R26
	MOV  R16,R30
	RJMP _0x200007B
_0x200007A:
	LDI  R20,LOW(1)
_0x200007B:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200007C
	__GETW1SX 88
	SBIW R30,4
	__PUTW1SX 88
	__GETW2SX 88
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x2000102
_0x200007C:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200007E
	__GETW1SX 88
	SBIW R30,4
	__PUTW1SX 88
	__GETW2SX 88
	ADIW R26,4
	CALL __GETW1P
	CALL __CWD1
	RJMP _0x2000102
_0x200007E:
	__GETW1SX 88
	SBIW R30,4
	__PUTW1SX 88
	__GETW2SX 88
	ADIW R26,4
	CALL __GETW1P
	CLR  R22
	CLR  R23
_0x2000102:
	__PUTD1S 6
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x2000080
	LDD  R26,Y+9
	TST  R26
	BRPL _0x2000081
	__GETD1S 6
	CALL __ANEGD1
	__PUTD1S 6
	LDI  R30,LOW(45)
	STD  Y+19,R30
_0x2000081:
	LDD  R30,Y+19
	CPI  R30,0
	BREQ _0x2000082
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0x2000083
_0x2000082:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(65531)
	LDI  R31,HIGH(65531)
	AND  R30,R26
	MOV  R16,R30
_0x2000083:
_0x2000080:
	MOV  R19,R20
_0x200006C:
	MOV  R30,R16
	LDI  R31,0
	ANDI R30,LOW(0x1)
	BRNE _0x2000084
_0x2000085:
	CP   R17,R21
	BRSH _0x2000088
	CP   R19,R21
	BRLO _0x2000089
_0x2000088:
	RJMP _0x2000087
_0x2000089:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200008A
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x200008B
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(65531)
	LDI  R31,HIGH(65531)
	AND  R30,R26
	MOV  R16,R30
	LDD  R18,Y+19
	SUBI R17,LOW(1)
	RJMP _0x200008C
_0x200008B:
	LDI  R18,LOW(48)
_0x200008C:
	RJMP _0x200008D
_0x200008A:
	LDI  R18,LOW(32)
_0x200008D:
	ST   -Y,R18
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	SUBI R21,LOW(1)
	RJMP _0x2000085
_0x2000087:
_0x2000084:
_0x200008E:
	CP   R17,R20
	BRLO PC+3
	JMP _0x2000090
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	OR   R30,R26
	MOV  R16,R30
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x2000091
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(65531)
	LDI  R31,HIGH(65531)
	AND  R30,R26
	MOV  R16,R30
	LDD  R30,Y+19
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(87))
	SBCI R31,HIGH(-(87))
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x2000092
	SUBI R21,LOW(1)
_0x2000092:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0x2000091:
	LDI  R30,LOW(48)
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x2000093
	SUBI R21,LOW(1)
_0x2000093:
	SUBI R20,LOW(1)
	RJMP _0x200008E
_0x2000090:
	MOV  R19,R17
	LDD  R30,Y+18
	CPI  R30,0
	BRNE _0x2000094
_0x2000095:
	CPI  R19,0
	BREQ _0x2000097
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x2000098
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x2000103
_0x2000098:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LD   R30,X+
	STD  Y+10,R26
	STD  Y+10+1,R27
_0x2000103:
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x200009A
	SUBI R21,LOW(1)
_0x200009A:
	SUBI R19,LOW(1)
	RJMP _0x2000095
_0x2000097:
	RJMP _0x200009B
_0x2000094:
_0x200009D:
	__GETD1S 12
	__GETD2S 6
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x200009F
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x20000A0
	MOV  R30,R18
	LDI  R31,0
	ADIW R30,55
	RJMP _0x2000104
_0x20000A0:
	MOV  R30,R18
	LDI  R31,0
	SUBI R30,LOW(-87)
	SBCI R31,HIGH(-87)
_0x2000104:
	MOV  R18,R30
	RJMP _0x20000A2
_0x200009F:
	MOV  R30,R18
	LDI  R31,0
	ADIW R30,48
	MOV  R18,R30
_0x20000A2:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x20000A3
	RJMP _0x20000A4
_0x20000A3:
	CPI  R18,49
	BRSH _0x20000A6
	__GETD2S 12
	__CPD2N 0x1
	BRNE _0x20000A5
_0x20000A6:
	RJMP _0x20000A8
_0x20000A5:
	CP   R20,R19
	BRSH _0x2000105
	CP   R21,R19
	BRLO _0x20000AB
	MOV  R30,R16
	LDI  R31,0
	ANDI R30,LOW(0x1)
	BREQ _0x20000AC
_0x20000AB:
	RJMP _0x20000AA
_0x20000AC:
	LDI  R18,LOW(32)
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x20000AD
_0x2000105:
	LDI  R18,LOW(48)
_0x20000A8:
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	OR   R30,R26
	MOV  R16,R30
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	BREQ _0x20000AE
	MOV  R26,R16
	LDI  R27,0
	LDI  R30,LOW(65531)
	LDI  R31,HIGH(65531)
	AND  R30,R26
	MOV  R16,R30
	LDD  R30,Y+19
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(87))
	SBCI R31,HIGH(-(87))
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x20000AF
	SUBI R21,LOW(1)
_0x20000AF:
_0x20000AE:
_0x20000AD:
_0x20000A4:
	ST   -Y,R18
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	CPI  R21,0
	BREQ _0x20000B0
	SUBI R21,LOW(1)
_0x20000B0:
_0x20000AA:
	SUBI R19,LOW(1)
	__GETD1S 12
	__GETD2S 6
	CALL __MODD21U
	__PUTD1S 6
	LDD  R30,Y+18
	LDI  R31,0
	__GETD2S 12
	CALL __CWD1
	CALL __DIVD21U
	__PUTD1S 12
	CALL __CPD10
	BREQ _0x200009E
	RJMP _0x200009D
_0x200009E:
_0x200009B:
	MOV  R30,R16
	LDI  R31,0
	ANDI R30,LOW(0x1)
	BREQ _0x20000B1
_0x20000B2:
	CPI  R21,0
	BREQ _0x20000B4
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	ST   -Y,R31
	ST   -Y,R30
	RCALL __put_G100
	RJMP _0x20000B2
_0x20000B4:
_0x20000B1:
_0x20000B5:
_0x2000053:
_0x2000101:
	LDI  R17,LOW(0)
_0x2000034:
	RJMP _0x200002F
_0x2000031:
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,29
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0x20A0004
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
_0x20A0004:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret
_ftoa:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x202000D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2020000,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
	RJMP _0x20A0003
_0x202000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x202000C
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2020000,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
	RJMP _0x20A0003
_0x202000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x202000F
	__GETD1S 9
	CALL __ANEGF1
	__PUTD1S 9
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(45)
	ST   X,R30
_0x202000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2020010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2020010:
	LDD  R17,Y+8
_0x2020011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2020013
	__GETD2S 2
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__PUTD1S 2
	RJMP _0x2020011
_0x2020013:
	__GETD1S 2
	__GETD2S 9
	CALL __ADDF12
	__PUTD1S 9
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	__PUTD1S 2
_0x2020014:
	__GETD1S 2
	__GETD2S 9
	CALL __CMPF12
	BRLO _0x2020016
	__GETD2S 2
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 2
	SUBI R17,-LOW(1)
	RJMP _0x2020014
_0x2020016:
	CPI  R17,0
	BRNE _0x2020017
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2020018
_0x2020017:
_0x2020019:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BRNE PC+3
	JMP _0x202001B
	__GETD2S 2
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _floor
	__PUTD1S 2
	__GETD2S 9
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	MOV  R30,R16
	LDI  R31,0
	ADIW R30,48
	ST   X,R30
	MOV  R30,R16
	LDI  R31,0
	__GETD2S 2
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	__GETD2S 9
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 9
	RJMP _0x2020019
_0x202001B:
_0x2020018:
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x202001C
	RJMP _0x20A0002
_0x202001C:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(46)
	ST   X,R30
_0x202001D:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x202001F
	__GETD2S 9
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 9
	CALL __CFD1U
	MOV  R16,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	MOV  R30,R16
	LDI  R31,0
	ADIW R30,48
	ST   X,R30
	MOV  R30,R16
	LDI  R31,0
	__GETD2S 9
	CALL __CWD1
	CALL __CDF1
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 9
	RJMP _0x202001D
_0x202001F:
_0x20A0002:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20A0003:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	__GETD1S 0
	CALL __PUTPARD1
	CALL _ftrunc
	__PUTD1S 0
    brne __floor1
__floor0:
	__GETD1S 0
	RJMP _0x20A0001
__floor1:
    brtc __floor0
	__GETD2S 0
	__GETD1N 0x3F800000
	CALL __SWAPD12
	CALL __SUBF12
_0x20A0001:
	ADIW R28,4
	RET

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.DSEG
_GrLcdState_G000:
	.BYTE 0x6
_gbuf:
	.BYTE 0x400
_prevLet_G000:
	.BYTE 0x2
_stat_G000:
	.BYTE 0x1
_prevX_G000:
	.BYTE 0x1
_prevY_G000:
	.BYTE 0x1
_GBFont:
	.BYTE 0x6
_VBATTRY:
	.BYTE 0x4
__seed_G101:
	.BYTE 0x4
_p_S1030024:
	.BYTE 0x2

	.CSEG

	.CSEG
__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
